<?php

namespace BayDOC\Entry;

abstract class Base {
    protected ?int $id = null;
    protected array $row;
    protected \BayCMS\Base\BayCMSContext $context;
    protected string $message='';
    protected ?string $role = null;


    public function __construct(\BayCMS\Base\BayCMSContext $context, int $id = null)
    {
        $this->context = $context;
        $this->id = $id;
    }

    public function getId()
    {
        return $this->id;
    }

    public function getRow(): array
    {
        return $this->row;
    }
    public function getRole()
    {
        if($this->role===null) return 'admin';
        return $this->role;
    }

    public function locked(): bool
    {
        return ($this->row['locked']??'f') == 't';
    }
}