<?php

namespace BayDOC\Field;

class Anrede extends \BayCMS\Field\Select
{
    public function __construct(
        \BayCMS\Base\BayCMSContext $context,
        string $name,
        string|null $description = null,
        string $id = '',
        string $sql = '',
        string $help = '',
        string $label_css = '',
        string $input_options = '',
        string $post_input = '',
        string $placeholder = '',
        bool $no_add_to_query = false,
        bool $not_in_table = false,
        bool $non_empty = false,
        array|null $footnote = null,
        mixed $default_value = null,
        string $div_id = ''
    ) {
        parent::__construct(
            $context,
            $name,
            $description,
            $id,
            $sql,
            $help,
            $label_css,
            $input_options,
            $post_input,
            $placeholder,
            $no_add_to_query,
            $not_in_table,
            $non_empty,
            $footnote,
            $default_value,
            $div_id,
            true
        );

        $this->values = [
            ['Frau', $this->t('Ms', 'Frau')],
            ['Herr', $this->t('Mr', 'Herr')],
            ['-', $this->t('Dear', 'Guten Tag')]
        ];

    }

    public function getValue(): mixed
    {
        if ($this->value == '-')
            return null;
        return $this->value;
    }

    public function setValue($value): bool
    {
        if (isset($_POST[$this->name]) && !$_POST[$this->name]) {
            $this->value = null;
            if ($this->non_empty)
                $this->error = true;
            return $this->error;
        }
        if (!$value)
            $value = '-';
        return parent::setValue($value);
    }
}