<?php

namespace BayDOC\Field;

class FachSelectJS extends \BayCMS\Field\TextInput
{
    public function getInput($form): string
    {
        $out = "";
        $name = $this->name;


        $out .= '<input id="' . $this->getID($form) . '" name="' . $name . '" ';
        $out .= 'value="' . htmlspecialchars($this->getDisplayValue()) . '" ';
        if ($this->placeholder)
            $out .= ' placeholder="' . htmlspecialchars($this->placeholder) . '"';
        $out .= $this->input_options . '>';

        $out .= '<script>
            $("#' . $this->getID($form) . '").autocomplete({
                source: function(request, response){
                    $.getJSON("/'.$this->context->getOrgLinkLang().'/admin/baydoc/stgfaecher.php", {
                        json_query: request.term}, response )
                },
                select: function(event,ui){
                    $("#' . $this->getID($form) . '").val(ui.item.value)
                },
                change: function(event,ui){
                    if(! ui.item){
                        this.value=""
                        $("#' . $this->getID($form) . '").val("")
                    }
                },
                mustMatch: true,
                minLength: 1
            })
            </script>';

        if ($this->error)
            $out .= $this->addErrorClass($this->getID($form));
        return $out;
    }

}