<?php

namespace BayDOC\Field;

class OrgSelect extends \BayCMS\Field\Select
{
    public function __construct(
        \BayCMS\Base\BayCMSContext $context,
        string $name,
        string|null $description = null,
        string $id = '',
        string $sql = '',
        string $help = '',
        string $label_css = '',
        string $input_options = '',
        string $post_input = '',
        string $placeholder = '',
        bool $no_add_to_query = false,
        bool $not_in_table = false,
        bool $non_empty = false,
        array|null $footnote = null,
        mixed $default_value = null,
        string $div_id = '',
        bool $null = true,
        string $role = 'selbst',
        array $org_ids = null,
        string $table='baydoc'
    ) {
        parent::__construct(
            $context,
            $name,
            $description,
            $id,
            $sql,
            $help,
            $label_css,
            $input_options,
            $post_input,
            $placeholder,
            $no_add_to_query,
            $not_in_table,
            $non_empty,
            $footnote,
            $default_value,
            $div_id,
            $null
        );
        $lang = $context->lang;
        $lang2 = $context->lang2;
        if ($org_ids !== null)
            $this->db_query = "select l.id as id, non_empty(l.$lang,l.$lang2,45) as description,
        non_empty(l2.$lang,l2.$lang2) as group
        from lehrstuhl l, lehrstuhl l2, gehoert_zu g,  objekt o, objekt o2
        where g.id_parent=l2.id and g.id_lehr=l.id and l.id=o.id and o.geloescht is null
        and l2.id=o2.id and o2.geloescht is null and ".($table=='postdoc'?' l2.postdoc_profile>0 ':'')."
        l.id in (".implode(',',$org_ids).")
        order by rom2num(non_empty(l2.$lang,l2.$lang2)),2,1";
        else
            $this->db_query = "select l.id as id, non_empty(l.$lang,l.$lang2,45) as description,
        non_empty(l2.$lang,l2.$lang2) as group
        from lehrstuhl l, lehrstuhl l2, gehoert_zu g,  gehoert_zu g2, objekt o, objekt o2
        where g.id_parent=l2.id and g.id_lehr=l.id and l.id=o.id and o.geloescht is null
        and l2.id=o2.id and o2.geloescht is null and g2.id_lehr=g.id_parent and
        (l2.id=" . $context->getOrgId() . " or g2.id_parent=" . $context->getOrgId() . " or 5001=" . $context->getOrgId() .
                " or '" . addslashes($role) . "'='admin') and 
        ".($table=='postdoc'?' l2.postdoc_profile>0 ':'l.baydoc_profile>0')." 
        order by rom2num(non_empty(l2.$lang,l2.$lang2)),2,1";
    }
}