<?php

namespace BayDOC\Page\Admin;

class DocList extends \BayCMS\Page\Page
{

    public function page(string $pre_content = '', string $post_content = '')
    {
        $this->context->printHeader();
        echo $pre_content;

        $form = new \BayCMS\Fieldset\Form($this->context, table: 'baydoc', uname: 'baydoc');
        if ($this->context->get('row1', 'baydoc_profile') > 0)
            $form->addField(new \BayCMS\Field\Hidden($this->context, 'id_lehr', default_value: $this->context->getOrgId(), type: 'integer'));
        else
            $form->addField(new \BayCMS\Field\Select(
                $this->context,
                'id_lehr',
                'Einheit',
                non_empty: 1,
                null: 1,
                db_query: "select l.id, non_empty(l.de,l.en,45) as description,
        non_empty(l2.de,l2.en) as group
        from lehrstuhl l, lehrstuhl l2, gehoert_zu g, objekt o, objekt o2
        where g.id_parent=l2.id and g.id_lehr=l.id and l.id=o.id and o.geloescht is null
        and l2.id=o2.id and o2.geloescht is null and
        l.baydoc_profile>0 and (l2.id=" . $this->context->getOrgId() . " or '" . $this->context->org_folder . "'='ubt' or " . $this->context->getOrgId() . "=5001)
        order by 3,rom2num(non_empty(l.de,l.en)),1"

            ));
        $form->addField(new \BayDOC\Field\Anrede($this->context, 'Anrede', non_empty: 1));
        $form->addField(new \BayCMS\Field\TextInput($this->context, 'Vorname', non_empty: 1));
        $form->addField(new \BayCMS\Field\TextInput($this->context, 'Name', non_empty: 1));
        $form->addField(new \BayCMS\Field\Hidden($this->context, 'antrag', default_value: 'f'));
        $form->addField(new \BayCMS\Field\Hidden($this->context, 'admineintrag', default_value: 't'));

        $action = $_GET['aktion'] ?? '';
        if ($action == 'save') {
            $error = $form->setValues($_POST);
            if ($error) {
                $action = 'edit';
                $GLOBALS['TE']->printMessage("Bitte füllen Sie das Formular vollständig aus", 'danger');
            }
        }

        $id = null;
        if ($action == 'save') {
            $id = $form->save();
            $ok = pg_query_params(
                $this->context->getRwDbConn(),
                'select set_objekt_ls(d.id,d.id_lehr,$2,o.id_art,0)
					from objekt o, baydoc d where o.id=d.id and o.id=$1',
                [$id, $this->context->getOrgId()]
            );
            $ok = pg_query_params(
                $this->context->getRwDbConn(),
                'insert into baydoc_zulassung(id_stud,datum,id_kat,id_benutzer,id_lehr)
					select $1,now()::date,$4,$2,$3 except select id_stud,now()::date,id_kat,id_benutzer,id_lehr
					from baydoc_zulassung where id_stud=$1',
                [$id, $this->context->getUserId(), $_POST['id_lehr'], 1]
            );
            if ($this->context->getOrgId() == 5001) //GS
                $ok = pg_query_params(
                    $this->context->getRwDbConn(),
                    'insert into baydoc_zulassung(id_stud,datum,id_kat,id_benutzer,id_lehr)
						select $1,now()::date,$4,$2,$3 except select id_stud,now()::date,id_kat,id_benutzer,id_lehr
						from baydoc_zulassung where id_stud=$1',
                    [$id, $this->context->getUserId(), 5001, 1]
                );

        }

        if ($action == 'edit') {
            echo $form->getForm('Neuer Eintrag');
        }

        $sform = new \BayCMS\Fieldset\Form($this->context);
        $sform->addField(new \BayCMS\Field\TextInput($this->context, 'such', placeholder: 'Suchen'));
        $sform->addField(new \BayCMS\Field\Select($this->context, 's', values: [[0, 'alle Promovierende'], [1, 'aktuelle Promovierende'], [2, 'ehemalige Promovierende']]));
        $sform->setValues($_GET);
        echo $sform->getSearchForm();
        $filter = ($_GET['s'] ?? 0) ? " and z.id_status" . ($_GET['s'] == 2 ? '>' : '<=') . '4' : '';
        if ($_GET['such'] ?? '') {
            $filter .= " and (s.name ilike '" . pg_escape_string($this->context->getDbConn(), $_GET['such']) . "%' 
            or s.vorname ilike '" . pg_escape_string($this->context->getDbConn(), $_GET['such']) . "%')";
        }

        $list = new \BayCMS\Fieldset\BayCMSList(
            $this->context,
            "baydoc s, objekt_verwaltung" . $this->context->getOrgId() . " o,baydoc_getstudstatus(" . $this->context->getOrgId() . ") z, baydoc_zulassungskat k",
            's.id=o.id and z.id_stud=s.id and z.id_status=k.id and not s.antrag ' . $filter,
            id_query: 's.id',
            jquery_row_click: 1,
            qs: $sform->getQS(),
            new_button: 1,
            order_by: ["s.name||'aaa '||s.vorname", 2],
            auto_order: 1
        );
        $list->addField(new \BayCMS\Field\TextInput($this->context, 'Name', sql: "s.name||' '||s.vorname"));
        $list->addField(new \BayCMS\Field\TextInput($this->context, 'Status', sql: 'non_empty(k.de,k.en)'));
        echo $list->getTable($id);
        $this->context->printFooter();

    }
}