<?php

namespace BayDOC\Page\Admin;

use Exception;

class EventAnmeldung extends \BayCMS\Page\Page
{
    protected array $row;
    public function page()
    {
        if (isset($_GET['id_obj']) && !isset($_GET['id']))
            $_GET['id'] = $_GET['id_obj'];
        $obj = new \BayCMS\Base\BayCMSObject($this->context);
        $obj->pageCheck($_GET['id'] ?? 0, true);

        $res = pg_query(
            $this->context->getDbConn(),
            "select to_char(datum,'DD.MM.YYYY') as fdatum, non_empty(" . $this->context->getLangLang2('') . ") as titel,* from baydoc_events where id=$_GET[id]"
        );



        $this->row = pg_fetch_array($res, 0);

        $domain = new \BayCMS\Fieldset\Domain(
            $this->context,
            'ea',
            "Anmeldungen " . $this->row['titel'] . " (" . $this->row['fdatum'] . ")",
            qs: 'id=' . $_GET['id'],
            id_name: 'id_doc',
            from: "(select t.*,l1.de as fg, l2.de as fak from
(select o.id, non_empty(d.email,p.email) as email,
    non_empty(o.de,o.en) as name,
    non_empty(d.vorname,p.vorname) as vorname,
    non_empty(d.name,p.name) as nachname,
    case when v.ordnung>100 then 'Ja' else 'Nein' end as warteliste,
    case when ao.uname='postdoc' then 'Postdocs' else 'Promovierende' end as gruppe,
    case when d.id_lehr is null then p.id_lehr else d.id_lehr end
    from objekt o, art_objekt ao, verweis v 
    left outer join baydoc d on d.id=v.id_von
    left outer join postdoc p on p.id=v.id_von 
    where 
    o.id_art=ao.id and o.geloescht is null and o.id=v.id_von and v.id_auf=" . $_GET['id'] . ") t,
lehrstuhl l1, gehoert_zu gz, lehrstuhl l2 where t.id_lehr=l1.id and l1.id=gz.id_lehr and gz.id_parent=l2.id) t",
            where: 'true',
            comment: $this->actions()
        );
        $squery = '';
        if ($_GET['such'] ?? '') {
            $such = "'%" . pg_escape_string($this->context->getDbConn(), $_GET['such']) . "%'";
            $squery .= " and (t.name ilike $such)";
        }
        $domain->setListProperties(
            actions: [],
            new_button: false,
            squery: $squery
        );
        $domain->addField(new \BayCMS\Field\TextInput(
            $this->context,
            'such',
            'Name',
            no_add_to_query: 1
        ), search_field: 1);
        $domain->addField(new \BayCMS\Field\TextInput(
            $this->context,
            'name',
            'Vorname Name'
        ), list_field: 1);
        $domain->addField(new \BayCMS\Field\TextInput(
            $this->context,
            'Nachname',
        ));
        $domain->addField(new \BayCMS\Field\TextInput(
            $this->context,
            'Gruppe'
        ), list_field: 1);
        $domain->addField(new \BayCMS\Field\TextInput(
            $this->context,
            'Warteliste'
        ), list_field: 1);
        $domain->addField(new \BayCMS\Field\TextInput(
            $this->context,
            'email',
            'E-Mail'
        ));
        $domain->addField(new \BayCMS\Field\TextInput(
            $this->context,
            'fg',
            'Fachgruppe'
        ));
        $domain->addField(new \BayCMS\Field\TextInput(
            $this->context,
            'fak',
            'Faktultät'
        ));
        if ($_GET['id_doc'] ?? false) {
            $obj->load($_GET['id_doc']);
            header("Location: " . ($obj->uname == 'baydoc' ? 'index.php' : '../postdoc/index.php') . '?tab=event&id=' . $_GET['id_doc']);
            exit();
        }

        $domain->page();






    }

    protected function actions()
    {        
        if(! isset($GLOBALS['TE'])) $this->context->initTemplate();
        $out= '<p style="float:right">' . $GLOBALS['TE']->getActionLink('/' . $this->context->getOrgLinkLang() . '/admin/baydoc/events.php', 'zurück zur Übersicht', '', 'arrow-left') .
        '</p>';
        if ($this->context->getOrgId() != 5001)
            return $out;
        $tabset = new \BayCMS\Util\TabNavigation(
            $this->context,
            ['geld', 'email'],
            ['Geld', 'E-Mail'],
            qs: "id=" . $_GET['id']
        );
        $out.= $tabset->getNavigation();
        if (!isset($_GET['tab']))
            $_GET['tab'] = 'geld';
        $form = new \BayCMS\Fieldset\Form(
            $this->context,
            submit: ($_GET['tab'] == 'geld' ? 'ausführen' : 'senden'),
            cancel_button: false,
            qs: "id=$_GET[id]&tab=$_GET[tab]"
        );

        switch ($_GET['tab']) {
            case 'geld':
                $form->addField(new \BayCMS\Field\Date(
                    $this->context,
                    'datum',
                    'Buchungsdatum',
                    non_empty: 1,
                    default_value: $this->row['datum']
                ));
                $form->addField(new \BayCMS\Field\Number(
                    $this->context,
                    'betrag',
                    'Buchungsbetrag',
                    non_empty: 1,
                    default_value: $this->row['min_geld']
                ));
                if ($this->row['min_geld']) {
                    $form->addField(new \BayCMS\Field\Select(
                        $this->context,
                        'id_gkat',
                        'Kategorie',
                        db_query: "select id,non_empty(de,en) as description from baydoc_gkat order by 2",
                        null: 1,
                        non_empty: 1
                    ));
                }
                break;
            case 'email':
                $form->addField(new \BayCMS\Field\TextInput(
                    $this->context,
                    'subject',
                    'Betreff',
                    non_empty: 1
                ));
                $form->addField(new \BayCMS\Field\Textarea(
                    $this->context,
                    'notiz',
                    'Nachricht',
                    non_empty: 1
                ));
                $form->addField(new \BayCMS\Field\Select(
                    $this->context,
                    'Auswahl',
                    values: [["=", 'Teilnehmer'], [">", 'nur Warteliste'], ['>=', 'Teilnehmer + Warteliste']]
                ));
                $form->addField(new \BayCMS\Field\Select(
                    $this->context,
                    'sender',
                    'Absender',
                    values: [$this->context->get('row1', 'email'), $this->context->get('row1', 'user_email')]
                ));
                break;
        }
        $action = $_GET['aktion'] ?? false;
        unset($_GET['aktion']);
        if ($action == 'save') {
            $error = $form->setValues($_POST);
            if ($error)
                $action = false;
        }

        if ($action == 'save') {
            switch ($_GET['tab']) {
                case 'geld':
                    if ($this->row['min_geld']) {
                        $res = pg_query_params(
                            $this->context->getRwDbConn(),
                            'select ao.uname,g.id,d.id as did,non_empty(d.de,d.en) from
                        objekt d, art_objekt ao, verweis v, baydoc_geld g where
                        d.id_art=ao.id and d.id=v.id_von and v.id_auf=$1 and v.ordnung=100 and d.id=g.id_stud and g.id_event=$1 and g.kat=0
                        order by g.datum',
                            array($_GET['id'])
                        );
                        pg_prepare(
                            $this->context->getRwDbConn(),
                            'update_geld',
                            'update baydoc_geld set datum=$1,betrag=$2,kat=1 where id=$3'
                        );
                        pg_query(
                            $this->context->getRwDbConn(),
                            'begin'
                        );
                        if (!pg_num_rows($res))
                            $out .= $GLOBALS['TE']->getMessage('Nichts zu tun', 'danger');
                        for ($i = 0; $i < pg_num_rows($res); $i++) {
                            $r = pg_fetch_array($res, $i);
                            $out .= "Ändere Festlegung $r[id] von <a href=\"" . ($r['uname'] == 'postdoc' ? '../postdoc/' : '') .
                                "index.php?id=$r[did]&tab=geld\">$r[non_empty]</a><br/>";
                            pg_execute(
                                $this->context->getRwDbConn(),
                                'update_geld',
                                [$_POST['datum'], $_POST['betrag'], $r['id']]
                            );
                        }
                        pg_query($this->context->getRwDbConn(), 'commit');
                    } else {
                        $res = pg_query_params(
                            $this->context->getRwDbConn(),
                            'select d.id as did,non_empty(d.de,d.en) from
                                objekt d, art_objekt ao, verweis v where
                                d.id_art=ao.id and d.id=v.id_von and v.id_auf=$1 and v.ordnung=100 and d.id not in (
                                select id_stud from baydoc_geld where id_event=$1)
                                order by non_empty(d.de,d.en)',
                            array($_GET['id'])
                        );
                        pg_prepare(
                            $this->context->getRwDbConn(),
                            'insert_ausgabe',
                            'insert into baydoc_geld(id_stud,datum,was,kat,betrag,id_benutzer,id_gkat,id_event)
                                select $1,$2,non_empty(e.de,e.en),1,$3,$4,$5,e.id
                                from baydoc_events e where e.id=$6'
                        );
                        pg_prepare(
                            $this->context->getRwDbConn(),
                            'upsert_bewilligung',
                            'with upsert as (update baydoc_geld set betrag=betrag+$3 where id_gkat=$5 and id_stud=$1 and kat=-1 
                                returning *) 
                                insert into baydoc_geld(id_stud,datum,was,kat,betrag,id_benutzer,id_gkat,id_event) 
                                select $1,$2,\'-\',-1,$3,$4,$5,e.id
                                from baydoc_events e where e.id=$6 and not exists (select * from upsert)'
                        );
                        pg_query($this->context->getRwDbConn(), 'begin');
                        if (!pg_num_rows($res))
                            $out .= $GLOBALS['TE']->getMessage('Nichts zu tun', 'danger');

                        for ($i = 0; $i < pg_num_rows($res); $i++) {
                            $r = pg_fetch_array($res, $i);
                            $out .= "Mache Buchung für <a href=\"" . ($r['uname'] == 'postdoc' ? '../postdoc/' : '') .
                                "index.php?id_obj=$r[did]&tab=geld\">$r[non_empty]</a><br/>";
                            pg_execute(
                                $this->context->getRwDbConn(),
                                'upsert_bewilligung',
                                [$r['did'], $_POST['datum'], $_POST['betrag'], $this->context->getUserId(), $_POST['id_gkat'], $_GET['id']]
                            );
                            pg_execute(
                                $this->context->getRwDbConn(),
                                'insert_ausgabe',
                                [$r['did'], $_POST['datum'], $_POST['betrag'], $this->context->getUserId(), $_POST['id_gkat'], $_GET['id']]
                            );
                        }
                        pg_query($this->context->getRwDbConn(), 'commit');


                    }
                    break;
                case 'email':
                    if (!in_array($_POST['auswahl'], array("=", ">", ">=")))
                        $_POST['auswahl'] = "=";
                    $res = pg_query(
                        $this->context->getDbConn(),
                        'select o.id, non_empty(d.email,p.email) as email
                    from objekt o, art_objekt ao, verweis v
                    left outer join baydoc d on d.id=v.id_von
                    left outer join postdoc p on p.id=v.id_von
                    where
                    o.id_art=ao.id and o.geloescht is null and v.ordnung' . $_POST['auswahl'] . '100 and o.id=v.id_von and v.id_auf=' . $_GET['id']
                    );
                    $mailer = new \BayDOC\Util\Mail($this->context);
                    for ($i = 0; $i < pg_num_rows($res); $i++) {
                        $r = pg_fetch_array($res, $i);
                        $out .= "sending mail to " . $r['email'] . "<br/>";
                        $mailer->sendMail($r['email'], $_POST['subject'], $_POST['notiz'], [], $_POST['sender'], $r['id']);
                    }
                    break;
            }

        }
        $out .= $form->getForm($_GET['tab'] == 'geld' ? "Festlegungen in Buchungen umwandeln" : "Teilnehmer informieren");
        $out .= "<br/><br/>";

        return $out;

    }

}