<?php

namespace BayDOC\Page\Admin;

class PostdocList extends \BayCMS\Page\Page
{

    public function page(string $pre_content = '', string $post_content = '')
    {
        $this->context->printHeader();
        echo $pre_content;

        $form = new \BayCMS\Fieldset\Form($this->context, table: 'postdoc', uname: 'postdoc');
        
            $form->addField(new \BayCMS\Field\Select(
                $this->context,
                'id_lehr',
                'Einheit',
                non_empty: 1,
                null: 1,
                db_query: "select l.id, non_empty(l.de,l.en,45) as description
        from lehrstuhl l,objekt o
        where l.id=o.id and o.geloescht is null and	l.postdoc_profile>0
        order by rom2num(non_empty(l.de,l.en)),1"

            ));
        $form->addField(new \BayDOC\Field\Anrede($this->context, 'Anrede', non_empty: 1));
        $form->addField(new \BayCMS\Field\TextInput($this->context, 'Vorname', non_empty: 1));
        $form->addField(new \BayCMS\Field\TextInput($this->context, 'Name', non_empty: 1));
        $form->addField(new \BayCMS\Field\Hidden($this->context, 'antrag', default_value: 'f'));

        $action = $_GET['aktion'] ?? '';
        if ($action == 'save') {
            $error = $form->setValues($_POST);
            if ($error) {
                $action = 'edit';
                $this->context->TE->printMessage("Bitte füllen Sie das Formular vollständig aus", 'danger');
            }
        }

        $id = null;
        if ($action == 'save') {
            $id = $form->save();
            pg_query_params(
                $this->context->getRwDbConn(),
                'select set_objekt_ls(d.id,d.id_lehr,$2,o.id_art,0)
					from objekt o, postdoc d where o.id=d.id and o.id=$1',
                [$id, $this->context->getOrgId()]
            );
            $this->context->TE->printMessage("Eintrag gespeichert");


        }

        if ($action == 'edit') {
            echo $form->getForm('Neuer Eintrag');
        }

        $sform = new \BayCMS\Fieldset\Form($this->context);
        $sform->addField(new \BayCMS\Field\TextInput($this->context, 'such', placeholder: 'Suchen'));
        $sform->addField(new \BayCMS\Field\Select($this->context, 's', values: [[0, 'alle Postdocs'], [1, 'nur aktive'], [2, 'nur inaktive']]));
        $sform->setValues($_GET);
        echo $sform->getSearchForm();
        $filter = ($_GET['s'] ?? 0) ? " and s.aktiv=" . ($_GET['s'] == 2 ? 'false' : 'true')  : '';
        if ($_GET['such'] ?? '') {
            $filter .= " and (s.name ilike '" . pg_escape_string($this->context->getDbConn(), $_GET['such']) . "%' 
            or s.vorname ilike '" . pg_escape_string($this->context->getDbConn(), $_GET['such']) . "%')";
        }

        $list = new \BayCMS\Fieldset\BayCMSList(
            $this->context,
            "postdoc s, objekt_verwaltung" . $this->context->getOrgId() . " o",
            's.id=o.id ' . $filter,
            id_query: 's.id',
            jquery_row_click: 1,
            qs: $sform->getQS(),
            new_button: 1,
            order_by: ["s.name||'aaa '||s.vorname", 2],
            auto_order: 1
        );
        $list->addField(new \BayCMS\Field\TextInput($this->context, 'Name', sql: "s.name||' '||s.vorname"));
        $list->addField(new \BayCMS\Field\TextInput($this->context, 'Aktiv', sql: "case when s.aktiv then 'Ja' else 'Nein' end"));
        echo $list->getTable($id);
        $this->context->printFooter();

    }
}