<?php

namespace BayDOC\Page\Admin;


class Prof extends \BayCMS\Page\Page
{
    private \BayDOC\Entry\Prof $prof;

    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        parent::__construct($context);
        $this->prof = new \BayDOC\Entry\Prof($context, $_GET['id']);
    }
    public function page()
    {
        $this->context->printHeader();
        $this->prof->printHead();
        $reiter = [
            'stamm',
            'betr',
            'ment',
            'gut',
            'postdoc',
            'email'
        ];
        $reiter_namen = ['Stammdaten', 'Doktoranden', 'Mentorate', 'Gutachten (ab 2022)', 'Habilitanden', 'E-Mails'];

        $nav = new \BayCMS\Util\TabNavigation(
            $this->context,
            $reiter,
            $reiter_namen,
            qs: 'id=' . ($_GET['id'] ?? '')
        );
        echo $nav->getNavigation();
        switch ($_GET['tab'] ?? 'stamm') {
            case 'stamm':
                $tab = new \BayDOC\Tabs\ProfStamm($this->context, $this->prof);
                break;
            case 'betr':
            case 'ment':
                $tab = new \BayDOC\Tabs\ProfDoc($this->context, $this->prof, $_GET['tab']);
                break;
            case 'gut':
                $tab = new \BayDOC\Tabs\ProfGutachten($this->context, $this->prof);
                break;
            case 'postdoc':
                $tab = new \BayDOC\Tabs\ProfPostdoc($this->context, $this->prof);
                break;
            case 'email':
                $tab = new \BayDOC\Tabs\TabEmail($this->context, $this->prof);
                break;
        }
        $tab->print();

        $this->context->printFooter();

    }
}