<?php

namespace BayDOC\Page\Admin;

class ProfList extends \BayCMS\Page\Page
{
    public function page(string $pre_content = '', string $post_content = '')
    {
        $this->context->printHeader();
        echo $pre_content;

        $form = new \BayCMS\Fieldset\Form($this->context, table: 'bayprof', uname: 'bayprof');
        $form->addField(new \BayDOC\Field\Anrede($this->context, 'Anrede', non_empty: 1));
        $form->addField(new \BayCMS\Field\TextInput($this->context, 'titel', 'Titel', non_empty: 1));
        $form->addField(new \BayCMS\Field\TextInput($this->context, 'vname', 'Vorname', non_empty: 1));
        $form->addField(new \BayCMS\Field\TextInput($this->context, 'nname', 'Nachname', non_empty: 1));

        $action = $_GET['aktion'] ?? '';
        if ($action == 'save') {
            $error = $form->setValues($_POST);
            if ($error) {
                $action = '';
                $GLOBALS['TE']->printMessage("Bitte füllen Sie das Formular vollständig aus", 'danger');
            }
        }

        $id=null;
        if ($action == 'save') {
            $id = $form->save();
        }
        if ($action == 'edit') {
            echo $form->getForm('Neuer Eintrag');
        }

        $sform = new \BayCMS\Fieldset\Form($this->context);
        $sform->addField(new \BayCMS\Field\TextInput($this->context, 'such', placeholder: 'Suchen'));
        $sform->setValues($_GET);
        echo $sform->getSearchForm();
        $filter='true';
        if ($_GET['such'] ?? '') {
            $filter .= " and (t.nname ilike '" . pg_escape_string($this->context->getDbConn(), $_GET['such']) . "%' 
            or t.vname ilike '" . pg_escape_string($this->context->getDbConn(), $_GET['such']) . "%')";
        }
        $list = new \BayCMS\Fieldset\BayCMSList(
            $this->context,
            "(select s1.id,s1.nname,s1.vname,s1.titel,s1.sum as sum1,s2.sum as sum2
  		from (select p.id,p.nname,p.vname,p.titel,sum(case when d.id is null then 0 else 1 end) as sum
  		from objekt_verwaltung".$this->context->getOrgId()." o, bayprof p left outer join baydoc d on d.b_id=p.id  and not d.antrag 
  		and d.ubt_status<=4
  		where o.id=p.id group by 1,2,3) s1 
  		join
  		(select p.id,sum(case when d_m.id is null then 0 else 1 end) as sum
  		from objekt_verwaltung".$this->context->getOrgId()." o, bayprof p  
 left outer join baydoc d_m on (d_m.m1_id=p.id or d_m.m2_id=p.id or d_m.m3_id=p.id) and not d_m.antrag
  		and d_m.ubt_status<=4
 		where o.id=p.id group by 1) s2 on s1.id=s2.id) t",
            $filter,
            id_query: 't.id',
            jquery_row_click: 1,
            qs: $sform->getQS(),
            new_button: 1,
            order_by:['t.nname||t.vname','t.sum1','t.sum2'],
            auto_order:1
        );
        $list->addField(new \BayCMS\Field\TextInput($this->context, 'Name', sql: "t.titel||' '||t.vname||' '||t.nname"));
        $list->addField(new \BayCMS\Field\TextInput($this->context, 'Betreute Doktoranden', sql: 't.sum1'));
        $list->addField(new \BayCMS\Field\TextInput($this->context, 'Mentorate', sql: 't.sum2'));
        echo $list->getTable($id);
        $this->context->printFooter();


    }

}
