<?php

namespace BayDOC\Page\Admin;

class Run extends \BayCMS\Page\Page
{
    public function page(string $pre_content = '', string $post_content = '')
    {
        $this->context->printHeader();
        echo $pre_content;
        echo "<h3>Stapelverarbeitung</h3>";
        //Allowed IDs
        $res = pg_query($this->context->getDbConn(), "select l.id
		from lehrstuhl l, lehrstuhl l2, gehoert_zu g, objekt o, objekt o2, in_ls i
		where g.id_parent=l2.id and g.id_lehr=l.id and l.id=o.id and o.geloescht is null
		and l2.id=o2.id and o2.geloescht is null and l2.id=g.id_parent and
		(i.id_benutzer=" . $this->context->getUserId() . " and (i.power>1000 or (i.power=1000 and i.id_lehr=l2.id) or
		(i.power=1000 and i.id_lehr=l.id)) or (i.power=1000 and i.id_lehr in
	(select id from lehrstuhl where de = 'Universität Bayreuth'))) and
		(l.baydoc_profile>0 or l.id=5001)");
        $id_hash = [];
        for ($i = 0; $i < pg_num_rows($res); $i++) {
            list($key) = pg_fetch_row($res, $i);
            $id_hash[$key] = 1;
        }


        $form = new \BayCMS\Fieldset\Form($this->context);
        $form->addField(new \BayCMS\Field\SelectJSMulti(
            $this->context,
            'Doktoranden',
            target: '../../admin/baydoc/docs.php',
            non_empty: 1,
            db_query: 'select id,vorname||\' \'||name as description from baydoc where id in (${in})'
        ));
        $form->addField(new \BayCMS\Field\Select($this->context, 'Aktion', values: ['Annahme als Doktorand'], null: 1, non_empty: 1));
        $form->addField(new \BayCMS\Field\Date(
            $this->context,
            'zulassung_zulassung',
            'Datum Annahme zur Promotion (relevant für EF13 - siehe Hilfetext)',
            help: 'Die Meldung von EF13 berücksichtigt: (1) Promotionsbeginn an vorheriger Universität,  (2) Minimum aus Datum Annahme zur Promotion und Datum Zulassungsveraussetzungen geprüft (3) Start der Promotion (veraltet) '
        ));
        $form->addField(new \BayCMS\Field\Textarea(
            $this->context,
            'zulassung_promordnung',
            'Promotionsordnung',
            help: 'Promotion nach Promotionsordnung vom ...'
        ));
        $form->addField(new \BayCMS\Field\Select(
            $this->context,
            'id_lehr',
            'Einheit für Statuseintrag',
            help: 'Wenn leer wird die Hauptzugehörigkeit des Doktoranden verwendet.',
            null: 1,
            db_query: "select distinct
			l.id, non_empty(l.de,l.en,45) as description,
			non_empty(l2.de,l2.en) as group,rom2num(non_empty(l2.de,l2.en))
			from lehrstuhl l, lehrstuhl l2, gehoert_zu g, objekt o, objekt o2
			where g.id_parent=l2.id and g.id_lehr=l.id and l.id=o.id and o.geloescht is null
			and l2.id=o2.id and o2.geloescht is null and l2.id=g.id_parent and l.id in
			(" . implode(',', array_keys($id_hash)) . ")
			order by rom2num(non_empty(l2.de,l2.en)),2"
        ));
        $form->addField(new \BayCMS\Field\Textarea(
            $this->context,
            'Bemerkung',
            non_empty: 1
        ));

        $action = $_GET['aktion'] ?? '';
        if ($action == 'save') {
            switch ($_POST['aktion']) {
                case "Annahme als Doktorand":
                    $form->getField("zulassung_zulassung")->non_empty = 1;
                    $form->getField("zulassung_promordnung")->non_empty = 1;
                    break;
            }
            $error = $form->setValues($_POST);
            if ($error) {
                $action = '';
                $GLOBALS['TE']->printMessage("Bitte füllen Sie das Formular vollständig aus", 'danger');
            }
        }

        if ($action == 'save') {
            switch ($_POST['aktion']) {
                case "Annahme als Doktorand":
                    pg_prepare($this->context->getRwDbConn(), 'update_doc', 'update baydoc set zulassung_zulassung=$2,zulassung_promordnung=$3 where id=$1');
                    pg_prepare($this->context->getRwDbConn(), 'insert_status', 'insert into baydoc_zulassung(id_stud,datum,id_kat,bemerkung,id_benutzer,id_lehr)
    values ($1,$2,3,\'Stapelverarbeitung\',' . $this->context->getUserId() . ',$3)');

                    break;
            }
            pg_prepare($this->context->getRwDbConn(), 'insert_verfahren', 'insert into baydoc_verfahren(id_benutzer,id_stud,wann,bemerkung) values 
    (' . $this->context->getUserId() . ',$1,now(),\'Stapelverarbeitung: \'||$2)');

            pg_prepare($this->context->getRwDbConn(), 'get_doc', 'select name,vorname,id_lehr,check_objekt(id,' . $this->context->getUserId() . '),locked from baydoc where id=$1');
            $ids = explode(",", $_POST['doktoranden']);
            $ids_failed = array();
            for ($i = 0; $i < count($ids); $i++) {
                $res = pg_execute($this->context->getRwDbConn(), 'get_doc', array($ids[$i]));
                $r = pg_fetch_array($res, 0);
                if ($r['check_objekt'] != 't') {
                    $GLOBALS['TE']->printMessage("Keine Rechte an $r[vorname] $r[name]", 'danger');
                    $ids_failed[] = $ids[$i];
                    continue;
                }
                if ($r['locked'] == 't') {
                    $GLOBALS['TE']->printMessage("$r[vorname] $r[name] ist für Änderungen gesperrt", 'danger');
                    $ids_failed[] = $ids[$i];
                    continue;
                }
                pg_query($this->context->getRwDbConn(), 'begin');
                switch ($_POST['aktion']) {
                    case "Annahme als Doktorand":
                        if ($_POST['id_lehr'] == "null")
                            $id_lehr = $r['id_lehr'];
                        else
                            $id_lehr = $_POST['id_lehr'];
                        $ok = pg_execute($this->context->getRwDbConn(), 'update_doc', array($ids[$i], $_POST['zulassung_zulassung'], $_POST['zulassung_promordnung']));
                        if ($ok)
                            $ok = pg_execute($this->context->getRwDbConn(), 'insert_status', array($ids[$i], $_POST['zulassung_zulassung'], $id_lehr));
                }
                if ($ok)
                    $ok = pg_execute($this->context->getRwDbConn(), 'insert_verfahren', array($ids[$i], $_POST['bemerkung']));
                if ($ok) {
                    pg_query($this->context->getRwDbConn(), 'commit');
                    $GLOBALS['TE']->printMessage("$r[vorname] $r[name] erfolgreich geändert");

                } else {
                    pg_query($this->context->getRwDbConn(), 'rollback');
                    $ids_failed[] = $ids[$i];
                    $GLOBALS['TE']->printMessage("Fehler beim Bearbeiten von $r[vorname] $r[name]", 'danger');
                }

            }
            $_POST['doktoranden'] = implode(",", $ids_failed);
            $form->setValues($_POST);

        }

        echo $form->getForm();
        echo '<script type="text/javascript">
<!--

function show_fields(){
	$("#form1_zulassung_promordnung").parent().hide();
	$("#form1_zulassung_zulassung").parent().hide();
	$("#form1_id_lehr").parent().hide();
	console.log($("#form1_aktion").val());
	switch($("#form1_aktion").val()){
	case "Annahme als Doktorand":
		$("#form1_zulassung_promordnung").parent().show();
		$("#form1_zulassung_zulassung").parent().show();
		$("#form1_id_lehr").parent().show();
		break;
	}
}
show_fields();

$("#form1_aktion").change(function(){
	show_fields();
})
//-->
</script>';


        echo $post_content;
        $this->context->printFooter();

    }

}