<?php

namespace BayDOC\Page;

use Exception;

class AntragPdf extends \BayCMS\Page\Page
{
    private array $res;

    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        parent::__construct($context);
        $id_org = isset($_GET['gs']) ? 5001 : $context->getOrgId();
        if (isset($_GET['id']))
            $id = $_GET['id'];
        elseif (isset($_GET['id_obj']))
            $id = $_GET['id_obj'];
        else {
            $res = pg_query_params(
                $context->getDbConn(),
                'select id from baydoc where id_benutzer=$1 or id_benutzer2=$1',
                [$context->getUserId()]
            );
            if (!pg_num_rows($res)) {
                $this->error(404, 'No ID given');
            }

        }

        $res = pg_query_params(
            $context->getDbConn(),
            "select d.*,to_char(d.pstart,'DD.MM.YYYY') as fpstart,to_char(d.gdatum,'DD.MM.YYYY') as fgdatum,
        to_char(now()::date,'DD.MM.YYYY') as fdatum,
        b.nname||', '||b.vname as betreuer,
        m1.nname||', '||m1.vname as mentor1,
        m2.nname||', '||m2.vname as mentor2,
        m3.nname||', '||m3.vname as mentor3,
        baydoc_getstatus(d.id,\$2)
        from baydoc d
        left outer join bayprof b on b.id=d.b_id
        left outer join bayprof m1 on m1.id=d.m1_id
        left outer join bayprof m2 on m2.id=d.m2_id
        left outer join bayprof m3 on m3.id=d.m3_id
        where d.id=\$1 and check_objekt(d.id,\$3)",
            [$id, $id_org, $context->getUserId()]
        );

        if (!pg_num_rows($res)) {
            $this->error(401, "Access to $id denied");
        }
        $r = pg_fetch_array($res, 0);

        $r['datum'] = date('d.m.Y');
        $r['absender'] = strtoupper($r['name']) . ", $r[vorname]
        
        $r[str]
        $r[ort]";
        $r['vorname_name'] = "($r[vorname] $r[name])";
        $r['vorname_name_ok'] = "$r[vorname] $r[name]";
        $r['bm1'] = $r['betreuer'];
        $r['bm2'] = $r['mentor1'];
        $r['bm3'] = $r['mentor2'];
        $r['bm4'] = $r['mentor3'];

        $vorlage = "admin/$id_org/baydoc_anschreiben_" . $context->lang . ".pdf";
        if (!is_readable($context->get('BayCMSRoot') . '/' . $vorlage))
            $vorlage = "admin/$id_org/baydoc_anschreiben.pdf";
        if (!is_readable($context->get('BayCMSRoot') . '/' . $vorlage))
            $vorlage = "inc/baydoc/baydoc_anschreiben.pdf";
        if (!is_readable($context->get('BayCMSRoot') . '/' . $vorlage))
            $this->error(501, 'No template found');

        $vorlage=$context->get('BayCMSRoot') . '/' . $vorlage;
        $background = '';
        if (!$r['baydoc_getstatus'])
            $background = $context->get('BayCMSRoot') . "/inc/baydoc/entwurf.pdf";

        $writer = new \BayCMS\Util\PDFWriter([$r], $vorlage, $background);
        try {
            $this->res = $writer->write();
        } catch (Exception $e) {
            $this->error(500, $e->getMessage());
        }

    }

    public function page()
    {
        header('Content-Description: antrag.pdf');
        header("Content-type: application/pdf");
        header("Content-Transfer-Encoding: binary");
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        //header('Pragma: public');
        //header('Accept-Ranges: bytes');
        header("Content-Length: " . filesize($this->res['tmp_name']));
        header("Content-disposition: inline; filename=antrag.pdf"); // prompt to save to disk
        ob_clean();
        flush();
        readfile($this->res['tmp_name']);
        unlink($this->res['tmp_name']);
        exit;


    }
}