<?php

namespace BayDOC\Page;



class Doc extends \BayCMS\Page\Page
{
    private \BayDOC\Entry\Doc $doc;

    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        parent::__construct($context);
        if(isset($_GET['id_obj']) && ! isset($_GET['id'])) $_GET['id']=$_GET['id_obj'];
        if($_GET['id']??false) $context->checkObject($_GET['id']);
        if(($_GET['id']??false)=='') $_GET['id']=null;
        $this->doc = new \BayDOC\Entry\Doc($context, $_GET['id'] ?? null);
    }
    public function page(string $pre_content = '', string $post_content = '')
    {

        $this->context->printHeader();
        if(! $this->doc->getId() && $this->doc->getRole()=='admin'){
            echo 'Als Adminstrator wechseln Sie bitte in den <a href="/' . $this->context->getOrgLinkLang() . '/admin/baydoc/baydoc.php">Admin-Bereich</a>.';
            $this->context->printFooter();
        }
        
        $this->doc->printHead();

        $reiter = [
            'list',
            'stamm',
            'uni',
            'betr',
            'prom',
            'register',
            'verfahren',
            'hstatg',
            'lock',
            'status',
            'email',
            'pdf',
            'geld',
            'event',
            'pub',
            'admin',
            'gs',
            'ino',
            'ps'
        ];
        $reiter_namen = ($this->context->lang == 'de' ?
            [
                'Promovierende',
                'Stammdaten',
                'Ausbildung',
                'Betreuer',
                'Promotion',
                'Registrierung&nbsp;abschließen',
                'Verfahren',
                'HStatG',
                'Sperrung',
                'Status',
                'E-Mails',
                'Download',
                'Guthaben',
                'Veranstaltungen',
                'Publikationen',
                'Admin',
                'Graduate School',
                'INO',
                'Prüfung & Statistik'
            ] :
            [
                'PhD Students',
                'Personal&nbsp;data',
                'Education',
                'Supervisors',
                'PhD',
                'Finish&nbsp;registration',
                'Verfahren',
                'HStatG',
                'Status',
                'Lock',
                'E-Mails',
                'Download',
                'Credit',
                'Events',
                'Publications',
                'Admin',
                'Graduate School',
                'INO',
                'Examination & Statistics'
            ]);

        $role = $this->doc->getRole();
        $id = $this->doc->getId();

        $tab_aktiv = array(
            'list' => ($id===null && $role=='bm'),
            'stamm' => $id || ($role=='selbst' && $this->doc->getAntrag()),
            'uni' => $id,
            'betr' => $id,
            'prom' => $id,
            'register' => ($role == 'selbst' && $id && $this->doc->getAntrag()), //Neuer Standard
            'verfahren' => ($id && $role == 'admin'),
            'hstatg' => ($id && $role == 'admin'),
            'lock' => ($id && $role == 'admin'),
            'status' => ($id && $role == 'admin'),
            'email' => ($id && $role == 'admin'),
            'ps' => ($id && ($role == 'admin' || ($role == 'selbst' && !$this->doc->getAntrag()))),
            'geld' => (($this->doc->getStatus(5001) == 'zulassung' || $role == 'admin') && $id),
            'event' => (($this->doc->getStatus(5001) == 'zulassung' ||
                $this->doc->getStatus($this->doc->getOrgId()) == 'zulassung') && $id),
            'pdf' => ($id && ($role == 'admin' || ($role == 'selbst' && !$this->doc->getAntrag()))),
            'pub' => (($this->doc->getStatus(5001) == 'zulassung' || $role == 'admin') && $id),
            'admin' => ($id && $role == 'admin' && \BayDOC\Util\AdminFields::getAdminFields($this->context->getOrgId())),
            'gs' => ($id && ($role == 'selbst' || $role == 'admin') &&
                $this->context->getOrgId() != 5001 && !$this->doc->getAntrag()),
            'ino' => false
        );


        //Spezielle Aktivierung für INO
        if ($this->context->org_folder == 'ino') {
            $tab_aktiv['ino'] = true;
            $tab_aktiv['ver'] = false;
            $tab_aktiv['hstatg'] = false;
            $tab_aktiv['lock'] = false;
            $tab_aktiv['zu'] = false;
            $tab_aktiv['geld'] = false;
            $tab_aktiv['pub'] = false;
            $tab_aktiv['gs'] = false;
        }

        $tnames = [];
        $tdesc = [];
        for ($i = 0; $i < count($reiter); $i++) {
            if ($tab_aktiv[$reiter[$i]]) {
                $tnames[] = $reiter[$i];
                $tdesc[] = $reiter_namen[$i];
            }
        }

        $nav = new \BayCMS\Util\TabNavigation(
            $this->context,
            $tnames,
            $tdesc,
            qs: 'id=' . ($_GET['id'] ?? '')
        );

        
        //Redirect to "Stammdaten" when called with non active tab
        if(! in_array($_GET['tab']??'',$tnames)) $_GET['tab']=($role=='bm'?'list':'stamm');
        echo $nav->getNavigation();

        $prefix = 'Doc';
        if (in_array($_GET['tab'] ?? '', ['email', 'event', 'geld']))
            $prefix = 'Tab';
        $class = '\\BayDOC\\Tabs\\' . $prefix . ucfirst($_GET['tab'] ?? 'stamm');
        $tab = new $class($this->context, $this->doc);

        $tab->print();

        $this->context->printFooter();


    }
}