<?php

namespace BayDOC\Page;

use Exception;

class EventPdf extends \BayCMS\Page\Page
{
    private array $res;
    public function __construct(\BayCMS\Base\BayCMSContext $context, int $id_event, int $id = null)
    {
        parent::__construct($context);
        if ($id === null)
            $query = "(d.id_benutzer=" . $context->getUserId() . " or p.id_benutzer=" . $context->getUserId() . ")";
        else
            $query = "g.id_stud=$id";

        $res = pg_query(
            $context->getDbConn(),
            "select 
case when p.titel>'' then p.titel||' ' else '' end||
non_empty(d.vorname,p.vorname)||' '||non_empty(d.name,p.name) as name,
case when d.id is null then 'p' else 'd' end as vorlage
from baydoc_events e, baydoc_geld g
left outer join baydoc d on d.id=g.id_stud
left outer join postdoc p on p.id=g.id_stud, verweis v 
where e.id=$id_event and $query and v.id_von=g.id_stud and v.id_auf=e.id and e.id=g.id_event and g.kat=1 and check_objekt(g.id_stud," . $context->getUserId() . ")"
        );

        if (!pg_num_rows($res))
            $this->error(404, "Entry not found ($id_event, $id)");

        $r = pg_fetch_array($res, 0);

        $res = pg_query(
            $context->getDbConn(),
            "select f.name from file f, objekt o where 
        f.id=o.id and o.id_obj=$id_event and f.de='zert_$r[vorlage]'"
        );

        if (!pg_num_rows($res))
            $this->error(500, "Template not found");

        [$vorlage] = pg_fetch_row($res, 0);
        $vorlage = $context->get('BayCMSRoot') . "/" . $vorlage;
        if (!is_readable($vorlage))
            $this->error(500, "Template not readable");


        $writer = new \BayCMS\Util\PDFWriter([$r], $vorlage);
        try {
            $this->res = $writer->write();
        } catch (Exception $e){
            $this->error(500, "Error: " . $e->getMessage());
        }
            
    }


    public function page()
    {
        header('Content-Description: zertifikat.pdf');
        header("Content-type: application/pdf");
        header("Content-Transfer-Encoding: binary");
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        //header('Pragma: public');
        //header('Accept-Ranges: bytes');
        header("Content-Length: " . filesize($this->res['tmp_name']));
        header("Content-disposition: inline; filename=zertifikat.pdf"); // prompt to save to disk
        ob_clean();
        flush();
        readfile($this->res['tmp_name']);
        unlink($this->res['tmp_name']);
        exit;
    }
}