<?php

namespace BayDOC\Page\Help;

class Main extends \BayCMS\Page\Page
{
    private function Tabs()
    {
        echo "<h1>Karteireiter</h1>";
        $classes = ['TabEvent', 'TabGeld'];
        $nav = new \BayCMS\Util\TabNavigation(
            $this->context,
            $classes,
            ['Veranstaltungen', 'Guthaben'],
            qs: 'topic=Tabs'
        );
        echo $nav->getNavigation();

        $class = ($_GET['tab'] ?? 'TabEvent');
        if (!in_array($class, $classes))
            $class = 'TabEvent';

        $full_class = "\\BayDOC\\Tabs\\$class";
        echo "<h3>Klasse: $full_class</h3>";
        echo $full_class::help($this->context);
    }

    private function GM()
    {
        echo '<h1>Antragsverfahren Gleichstellungsmittel</h1>
<h3>Zulassung zum Antrag</h3>
<p>Das Antragsverfahren erfolgt in einem eigen passwortgeschützen Bereich "Gleichstellungsmittel". Damit Doktorandinnen und Postdocs Anträge
stellen können, müssen ihre bt-Kennungen für den Bereich als "normale Nutzer" freigeschaltet werden. Das erfolgt
am besten über <a href="../../admin/auth_unildap/add_ldap_user.php">Admin-Uni-LDAP-User</a>. Zum Freischalten genügt
die Uni-E-Mail-Adresse.</p>
<p>Zusätzlich zur Freischaltung wird geprüft, ob die Doktorandin Mitglied der Graduateschool ist bzw. ob beim Postdoc 
die "aktiv"-Checkbox gesetzt ist.
</p>
<h3>Vorbereitung des Antragsverfahren</h3>
<p>
Das Antragsverfahren ist so lange offen, wie eine aktive <a href="../../admin/baydoc/gm_deadline.php">Ausschreibung</a> existiert.
Die Antragsstellerin kann in diesem Zeitraum seinen Antrag beliebig oft bearbeiten oder auch löschen.
</p>
<h3>Rechte und Zugänge</h3>
<p>
Durch Absenden eines Antrags wird der Einheit ein Zugriffsrecht auf die Dokorandin/Postdoc eingetragen. 
Damit können Administratoren des Bereichs "Gleichstellungsmittel" in gleicher Weise auf die Einträge zugreifen 
wie Adminstratoren der Fakultäten.
</p>
<p>
Die Eintragsmöglichkeiten im Tab "Guthaben" werden ab BayDOC Version 2.18 über die Datenbank-Tabelle "baydoc_gkat_access" konfiguriert.
Die Einträge werden nur durch den Datenbankadministrator vorgenommen. Administratoren der Einheit "Gleichstellungsmittel"
bekommen die Eintragerechte für die Geldkategorie "Gleichstellungsmittel".
</p>
<h3>Administration</h3>
<p>
Akutell können Administratoren der Einheit "Gleichstellungsmittel" die Anträge einsehen und bearbeiten. 
Es fehlen jedoch noch eigens zu definierende Admin-Felder, die das Bewilligungsverfahren abbilden. Eine Abfrage-Möglichkeit
über die QueryBuilder-Funktion wird ebenfalls noch implementiert.
</p>';
    }

    

    private function Wahlberechtigte()
    {
        echo '<h1>Wahlberechtigte</h1>
    <table ' . $GLOBALS['TE']->getCSSClass('table') . '>
    <tr><td><h3>Fakultät</h3>
    Promotion an Fakultät oder Fakultät des ersten Betreuers</td>
    <td><pre>' . \BayDOC\Page\Admin\Wahlberechtigte::$fakultaet_sql . '</pre></td></tr>
    <tr><td><h3>Filter</h3>
    keine Urkunde, kein Abbruch + Status größer Antrag und kleiner Rücktritt von der Promotion + Mitglied der Graduatescool oder promotion in BayNAT, BIGSAS, BayKULT oder BayREW
    <td><pre>' . \BayDOC\Page\Admin\Wahlberechtigte::$filter . '</pre></td></tr>
    </table>';

    }

    private function Stat()
    {
        echo '<h1>Schlüsseltabellen für Statistik-Meldung</h1>
<ul>
<li><a href="../../admin/baydoc/stat_art.php">Art der Prüfung (EF26)</a></li>
<li><a href="../../admin/baydoc/stat_hr.php">Art der ersten HZB (EF32)</a></li>
<li><a href="../../admin/baydoc/stat_hs.php">Hochschule (EF19, EF24)</a></li>
<li><a href="../../admin/baydoc/stat_kreise.php">Ort (EF33)</a></li>
<li><a href="../../admin/baydoc/stat_laender.php">Land (EF20, EF25, EF33)</a></li>
<li><a href="../../admin/baydoc/stgfaecher.php">Fach (EF11, EF27)</a></li>
    
</ul>
';
        echo \BayDOC\Util\StatTables::help($this->context);

    }

    private function QB(){
        echo '<h1>Query Builder</h1>
        <ul>
        <li><a href="../../admin/baydoc/baydoc.php">Promovierende</a></li>
        <li><a href="../../admin/postdoc/admin.php">Postdocs</a></li>
        <li><a href="../../admin/baydoc/events.php">Veranstaltungen</a></li>
        <li><a href="../../admin/baydoc/buchung.php">Buchungen</a></li>
       <li><a href="../../admin/baydoc/events.php">Professoren</a></li>
</ul>
<p><a href="qb.php">Query Builder (Version 1 - veraltet)</a></p>

        ';
    }

    private function index()
    {
        echo '<h1>BayDOC technische Dokumentation</h1>
        <p>Hier werden konkrete Implementierungen dokumentiert. Die Dokumentation ist noch im Aufbau.<p>
        <p>Entgegen des BayCMS-Standards ist diese Dokumentation nur mit Admin-Rechten einsehbar.</p>
        
        <h3>Promovierende</h3>
        <ul>
        <li><a href="?topic=Tabs">Karteireiter</a></li>
        <li><a href="?topic=GM">Gleichstellungsmittel</a></li>
        </ul>
        
        <h3>Exportformate</h3>
        <ul>
        <li><a href="?topic=QB">QueryBuilder</a></li>
        <li><a href="?topic=Wahlberechtigte">Wahlberechtigte</a></li>
        </ul>
        
        
        <h3>Statistik</h3>
        <ul>
        <li><a href="?topic=Stat">Statistik-Tabellen</a></li>
        </ul>
        
        ';
    }



    public function page()
    {
        $this->context->printHeader();

        if ($_GET['topic'] ?? false){

            echo '<p style="float:right">' . $GLOBALS['TE']->getActionLink('?', 'zurück zur Übersicht', '', 'arrow-left') .
                '</p>';
            $fun=$_GET['topic'];
            $this->$fun();
        }
        else
            $this->index();

        $this->context->printFooter();
    }
}