<?php

namespace BayDOC\Page;


class Postdoc extends \BayCMS\Page\Page
{
    private \BayDOC\Entry\Postdoc $doc;

    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        parent::__construct($context);
        if (isset($_GET['id_obj']) && !isset($_GET['id']))
            $_GET['id'] = $_GET['id_obj'];
        if ($_GET['id'] ?? false)
            $context->checkObject($_GET['id']);
        if(($_GET['id']??false)=='') $_GET['id']=null;
        $this->doc = new \BayDOC\Entry\Postdoc($context, $_GET['id'] ?? null);
    }
    public function page(string $pre_content = '', string $post_content = '')
    {


        $this->context->printHeader();
        if (!$this->doc->getId() && $this->doc->getRole() == 'admin') {
            echo 'Als Adminstrator wechseln Sie bitte in den <a href="/' . $this->context->getOrgLinkLang() . '/admin/postdoc/admin.php">Admin-Bereich</a>.';
            $this->context->printFooter();
        }

        $this->doc->printHead();

        $reiter = [
            'stamm',
            'uni',
            'prom',
            'betr',
            'register',
            'jp',
            'habil',
            'email',
            'pdf',
            'geld',
            'event',
            'tg',
            'anstellung',
            'admin'
        ];
        $reiter_namen = ($this->context->lang == 'de' ?
            [
                'Stammdaten',
                'Ausbildung',
                'Promotion',
                'Betreuer',
                'Registrierung&nbsp;abschließen',
                'Junior Professur',
                'Habilitation',
                'E-Mails',
                'PDF/DOCX',
                'Guthaben',
                'Veranstaltungen',
                'Research Stay Grants',
                'Anstellungen',
                'Admin'
            ] :
            [
                'Personal&nbsp;data',
                'Education',
                'PhD',
                'Supervisors',
                'Finish&nbsp;registration',
                'Junior Professur',
                'Habilitation',
                'E-Mails',
                'PDF/DOCX',
                'Credit',
                'Events',
                'Research Stay grants',
                'Admin'
            ]);

        $role = $this->doc->getRole();
        $id = $this->doc->getId();
        $res = pg_query(
            $this->context->getDbConn(),
            "select tg.id from	postdoc_tg_deadline tg, objekt" . $this->context->getOrgId() . " o where tg.id=o.id"
        );
        $travel_grants = pg_num_rows($res);
        $events = 1;
        //Abfrage Conference Grants
        $conference_grants = 1;

        if (! $this->doc->isActive()) {
            $travel_grants = 0;
            $conference_grants = 0;
            $events = 0;
        }
        $tab_aktiv = array(
            'ueb' => ($role != 'selbst' && !$id),
            'stamm' => 1,
            'uni' => ($id && ( $role == 'admin')),
            'prom' => $id && (!$this->doc->getAntrag() || $role == 'admin'),
            'betr' => ($id && ($this->doc->getAntrag() || $role == 'admin')),
            'register' => ($role == 'selbst' && $id && $this->doc->getAntrag()),
            'jp' => ($id && $role == 'admin'),
            'habil' => ($id && $role == 'admin'),
            'email' => ($id && $role == 'admin'),
            'geld' => ($id && $role == 'admin'),
            'tg' => $travel_grants && ($id && ($role == 'admin' || ($role == 'selbst' && ! $this->doc->getAntrag()))),
            'event' => (((! $this->doc->getAntrag() && $events) || $role == 'admin') && $id),
            'pdf' => ($id && $role == 'admin'),
            'anstellung' => ($id && $role == 'admin'),
            'admin' => ($id && $role == 'admin' && false) //disabled currently
        );

        $tnames = [];
        $tdesc = [];
        for ($i = 0; $i < count($reiter); $i++) {
            if ($tab_aktiv[$reiter[$i]]) {
                $tnames[] = $reiter[$i];
                $tdesc[] = $reiter_namen[$i];
            }
        }

        $nav = new \BayCMS\Util\TabNavigation(
            $this->context,
            $tnames,
            $tdesc,
            qs: 'id=' . ($_GET['id'] ?? '')
        );
        //Redirect to "Stammdaten" when called with non active tab
        if (!in_array($_GET['tab'] ?? '', $tnames))
            $_GET['tab'] = 'stamm';
        echo $nav->getNavigation();

        $prefix = 'Postdoc';
        if (in_array($_GET['tab'] ?? '', ['email', 'event', 'geld']))
            $prefix = 'Tab';
        if (in_array($_GET['tab'] ?? '', ['stamm', 'betr']))
            $prefix = 'Doc';
        $class = '\\BayDOC\\Tabs\\' . $prefix . ucfirst($_GET['tab'] ?? 'stamm');
        $tab = new $class($this->context, $this->doc);

        $tab->print();

        $this->context->printFooter();


    }
}