<?php

namespace BayDOC\Page;

class Prof extends \BayCMS\Fieldset\Domain
{
    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        parent::__construct(
            $context,
            'bayprof',
            uname: 'bayprof',
            copy: false,
            object_button: false,
            name: $context->t('Supervisors', 'Betreuer'),
            erase_object:1
        );
        $squery = ' and t.aktiv';
        if ($_GET['prof'] ?? '') {
            $squery .= " and t.nname ilike '" . pg_escape_string($context->getDbConn(), $_GET['prof']) . "%'";
        }
        $this->setListProperties(
            export_buttons: 0,
            squery: $squery,
            actions:['edit']
        );
        $this->addField(
            new \BayCMS\Field\TextInput($context, 'prof', $this->t('Supervisor', 'Betreuer'), sql: "t.titel||' '||t.vname||' '||t.nname"),
            list_field: 1,
            search_field: 1,
            edit_field: 0
        );
        $this->addField(
            new \BayDOC\Field\Anrede($context, 'anrede', $this->t('Salutation', 'Anrede'), non_empty: 1)
        );
        $this->addField(
            new \BayCMS\Field\TextInput($context, 'titel', $this->t('Academic Title (e.g. Prof. Dr.)', 'Titel (z.B. Prof. Dr.)'), non_empty: 1)
        );
        $this->addField(
            new \BayCMS\Field\TextInput($context, 'nname', $this->t('Lastname', 'Nachname'), non_empty: 1)
        );
        $this->addField(
            new \BayCMS\Field\TextInput($context, 'vname', $this->t('Firstname', 'Vorname'), non_empty: 1)
        );
        $this->addField(
            new \BayCMS\Field\Email($context, 'email', $this->t('E-Mail', 'E-Mail'), non_empty: 1)
        );
        $this->addField(
            new \BayCMS\Field\URL($context, 'url', $this->t('Homepage (URL with http://..)', 'Homepage (URL mit http://..)'), non_empty: 1)
        );
    }

    public function page(string $pre_content='', string $post_content='')
    {
        $error='';
        
        if (($_GET['aktion']??'') == "del") {
            $res = pg_query_params($this->context->getDbConn(), 
            'select b.id from baydoc b, objekt o
			where (b.b_id=$1 or b.m1_id=$1 or b.m2_id=$1 or b.m3_id=$1) and b.id=o.id and o.geloescht is null',
            $_GET['id']);
            if (pg_num_rows($res)) {
                $this->error_string='Betreuer kann nicht gel&ouml;scht werden. Es gibt noch Doktoranden, die auf diesen Betreuer verweisen.';
                unset($_GET['aktion']);
            }
        }


        if (($_GET['aktion']??'') == 'save' && preg_match("/^[_\.0-9a-z-]+@[0-9a-z][-0-9a-z\.]+\.[a-z]*$/i", $_POST['email']) 
        && !is_numeric($_GET['id']??'')) {
            $res = pg_query_params($this->context->getDbConn(), 
            'select p.* from bayprof p, objekt o where p.email ilike $1 and p.id=o.id and o.geloescht is null', [$_POST['email']]);
            if (pg_num_rows($res)) {
                $r = pg_fetch_array($res, 0);
                $this->error_string=$this->t( 'There is already a database entry with this e-mail address. Please choose this on',
                'Es gibt bereits einen Eintrag mit dieser E-Mail-Adresse. Bitte wählen Sie diesen aus.');
                unset($_GET['aktion']);
                $_GET['prof'] = $r['nname'];
                $_GET['id'] = $r['id'];
            }
        }

        parent::page($error);
    }
}