<?php

namespace BayDOC\Page;

abstract class Stat extends \BayCMS\Fieldset\Domain
{
    public function __construct(\BayCMS\Base\BayCMSContext $context, string $table, string $name, string $sql, bool $alias = false)
    {
        $write = \BayDOC\Util\StatTables::writeAccess($context);
        parent::__construct(
            $context,
            $table,
            $name,
            copy: false,
            write_access_query: $write ? 'true' : 'false'
        );
        $squery = '';
        if ($_GET['json_query'] ?? false)
            $_GET['such'] = $_GET['json_query'];
        if ($_GET['such'] ?? '') {
            $such = "'%" . pg_escape_string($context->getDbConn(), $_GET['such']) . "%'";
            $squery .= " and ($sql ilike $such" . ($alias ? " or t.alias ilike $such" : "") . ")";
        }

        $this->setListProperties(
            export_buttons: $write,
            new_button: $write,
            squery: $squery,
            json_order_by: ['t.prio desc', 1],
            actions: $write ? ['edit'] : []
        );
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'such',
            $name,
            sql: $sql
        ), search_field: 1, list_field: 1, edit_field: 0);
    }
}