<?php

namespace BayDOC\Page;


class StatFaecher extends Stat
{
    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        $write = \BayDOC\Util\StatTables::writeAccess($context);
        parent::__construct(
            $context,
            'baydoc_stgfach',
            'Fächer',
            ($context->lang == 'de' ? "t.name" : "non_empty(t.en,t.name)") . "||' ('||t.signatur||')'",
            true
        );
        
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'signatur',
            'Schlüssel',
            non_empty: 1
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'signatur_gr',
            'Schlüssel Gruppe',
            non_empty: 1
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'name',
            'Name (deutsch)',
            non_empty: 1
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'en',
            'Name (englisch)',
            non_empty: 1
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'co',
            'Name (Campus Online)'
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'Alias'
        ));
        $this->addField(new \BayCMS\Field\Number(
            $context,
            'prio',
            'Priorität (je höher desto weiter oben)',
            non_empty: 1
        ));
    }
}