<?php

namespace BayDOC\Page;

class StatLaender extends Stat
{
    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        $write=\BayDOC\Util\StatTables::writeAccess($context);
        parent::__construct(
            $context,
            'stat_laender',
            'Länder',
            $context->lang=='de'?"t.name":"non_empty(t.en,t.name)"."||' ('||t.schluessel||')'",
            true
        );
        
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'schluessel',
            $context->t('Number','Schlüssel'),
            non_empty: 1
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'kennung',
            'Kennung',
            non_empty: 1
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'name',
            'Name (de)',
            non_empty: 1
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'en',
            'Name (en)',
            non_empty: 1
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'Alias'
        ));
        $this->addField(new \BayCMS\Field\Number(
            $context,
            'prio',
            'Priorität (je höher desto weiter oben)',
            non_empty: 1
        ));
        $this->addField(new \BayCMS\Field\Checkbox(
            $context,
            'eu',
            'EU-Land'
        ));
        $this->addField(new \BayCMS\Field\Checkbox(
            $context,
            'eu_gleich',
            'EU gleichgestellt'
        ));
    }
}