<?php

namespace BayDOC\QB\Mapper;

class Buchung extends Base
{

    protected $table_hash = [
        't' => 'd',
        'geld'=>'b'
    ];
    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        parent::__construct($context, 1);
        $this->old['fgroup'][0] = "Doktorand";
        $this->old['felder'] = array(
            'd.id',
            'd.anrede',
            'd.vorname',
            'd.name',
            'd.email',
            'd.gname',
            'd.gort',
            'd.gdatum',
            'd.str',
            'd.ort',
            'd.land',
            'd.tel',
            'd.homepage',
            'd.arbeitstitel',
            'd.pstart',
            "non_empty(k.de,k.en)",
            "non_empty(l.de,l.en)",
            "non_empty(pl.de,pl.en)",
            'd.coop',
            'd.coop_text',
            'd.land_wohnort',
            'd.land2',
            'd.funding',
            'd.funding_text'
        );

        $this->old['fnamen'] = array(
            'ID',
            'Anrede',
            'Vorname',
            'Nachname',
            'E-Mail',
            'Geburtsname',
            'Geburtsort',
            'Geburtsdatum',
            'Straße',
            'Ort',
            'Nationalität',
            'Telefon',
            'Homepage',
            'Arbeitstitel',
            'Promotionsbeginn',
            'Status',
            'Einheit',
            'Obereinheit',
            'Kooperation',
            'Kooperationseinrichtung',
            'Land Wohnort',
            '2. Nationalität',
            'Finanzierung',
            'Finanzierung (TEXT)'
        );
        $this->old['fgroup']['pb_name'] = 'Betreuer';
        $this->old['felder']['pb_name'] = 'pb.nname';
        $this->old['fnamen']['pb_name'] = "Name Erstbetreuer";
        $this->old['felder']['pb_vname'] = 'pb.vname';
        $this->old['fnamen']['pb_vname'] = "Vorname Erstbetreuer";
        $this->old['felder']['pb_ls'] = 'pb.lehrstuhl';
        $this->old['fnamen']['pb_ls'] = "Lehrstuhl Erstbetreuer";
        $this->old['felder']['b_name'] = "b.was";
        $this->old['fnamen']['b_name'] = "Name";
        $this->old['felder']['b_datum'] = "b.datum";
        $this->old['fnamen']['b_datum'] = "Datum";
        $this->old['felder']['b_id'] = "b.id";
        $this->old['fnamen']['b_id'] = "ID";
        $this->old['felder']['b_kat'] = "case when b.kat=-1 then 'Gutschrift' when b.kat=0 then 'Festlegung' when b.kat=1 then 'Ausgabe' else 'unbekannt' end";
        $this->old['fnamen']['b_kat'] = "Kategorie";
        $this->old['felder']['b_betrag'] = "b.betrag";
        $this->old['fnamen']['b_betrag'] = "Betrag";
        $this->old['felder']['e_kat'] = "non_empty(".$context->getLangLang2('gk.').")";
        $this->old['fnamen']['e_kat'] = "Geld-Kategorie";

        $qb = new \BayDOC\QB\Buchung($context);
        $sql_hash = [];
        $maps = [];
        foreach ($qb->getFields() as $f) {
            $sql_hash[$f->name] = $f->getSQL('t.', 'order');
        }

        $sql_hash_manual = [
        ];
        foreach ($this->old['felder'] as $key => $value) {
            if (isset($sql_hash_manual[$value])) {
                $value = $sql_hash_manual[$value];
            } else
                $value = $this->old2new($value);
            $keys = array_keys($sql_hash, $value);
            foreach ($keys as $name) {
                $this->field_map[$key] = $name;
                $maps[$name] = 1;
            }
        }

    }
}