<?php

namespace BayDOC\QB\Mapper;

class Doc extends Base
{

    protected $table_hash = [
        't' => 'd',
        'prof_b' => 'b',
        'prof_m1' => 'm1',
        'prof_m2' => 'm2',
        'prof_m3' => 'm3',
        'user1' => 'bn1',
        'user2' => 'bn2',
        'prom_prog' => 'l',
        'fak' => 'pl',
        'prom_fach' => 'stg',
        'bachelor_land' => 'ehs_land',
        'bachelor_hs' => 'ehs',
        'master_hs' => 'ahs',
        'master_land' => 'ahs_land',
        'master_art' => 'ahs_art',
        'master_fach' => 'ahs_fach',
        'hzb_art' => 'hzb',
        'staat1'=>'nat1',
        'staat2'=>'nat2'

    ];


    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        parent::__construct($context, 1);
        $row1 = $context->get('row1');

        $this->old['fgroup'][0] = "Stammdaten";
        $this->old['felder'][0] = 'd.id';
        $this->old['fnamen'][0] = 'ID';
        $this->old['felder'][1] = 'd.anrede';
        $this->old['fnamen'][1] = 'Anrede';
        $this->old['felder'][2] = 'd.vorname';
        $this->old['fnamen'][2] = 'Vorname';
        $this->old['felder'][3] = 'd.name';
        $this->old['fnamen'][3] = 'Nachname';
        $this->old['felder'][4] = 'd.email';
        $this->old['fnamen'][4] = 'E-Mail';
        $this->old['felder'][5] = 'd.gname';
        $this->old['fnamen'][5] = 'Geburtsname';
        $this->old['felder'][6] = 'd.gort';
        $this->old['fnamen'][6] = 'Geburtsort';
        $this->old['felder'][7] = 'd.gdatum';
        $this->old['fnamen'][7] = 'Geburtsdatum';
        $this->old['felder'][8] = 'd.str';
        $this->old['fnamen'][8] = 'Straße';
        $this->old['felder'][9] = 'd.ort';
        $this->old['fnamen'][9] = 'Ort';
        $this->old['felder'][20] = 'd.land_wohnort';
        $this->old['fnamen'][20] = 'Land Wohnort';
        $this->old['felder'][10] = 'd.land';
        $this->old['fnamen'][10] = 'Nationalität';
        $this->old['felder'][21] = 'd.land2';
        $this->old['fnamen'][21] = '2. Nationalität';
        $this->old['felder'][11] = 'd.tel';
        $this->old['fnamen'][11] = 'Telefon';
        $this->old['felder'][12] = 'd.homepage';
        $this->old['fnamen'][12] = 'Homepage';
        $this->old['felder'][13] = 'd.arbeitstitel';
        $this->old['fnamen'][13] = 'Arbeitstitel';
        $this->old['felder'][14] = 'd.pstart';
        $this->old['fnamen'][14] = 'Promotionsbeginn an UBT (veraltet)';
        $this->old['felder']['14_2'] = 'd.pstart2';
        $this->old['fnamen']['14_2'] = 'Promotionsbeginn an 1. Universität';
        $this->old['felder']['fasttrack'] = 'd.fasttrack';
        $this->old['fnamen']['fasttrack'] = 'Fasttrack';
        $this->old['felder'][15] = "non_empty(k.de,k.en)";
        $this->old['fnamen'][15] = 'Status';
        $this->old['felder'][16] = "non_empty(l.de,l.en)";
        $this->old['fnamen'][16] = 'Einheit';
        $this->old['felder'][17] = "non_empty(pl.de,pl.en)";
        $this->old['fnamen'][17] = 'Obereinheit';
        $this->old['felder'][18] = 'd.coop';
        $this->old['fnamen'][18] = 'Kooperation';
        $this->old['felder'][19] = 'd.coop_text';
        $this->old['fnamen'][19] = 'Kooperationseinrichtung';
        $this->old['felder'][22] = 'd.funding';
        $this->old['fnamen'][22] = 'Finanzierung';
        $this->old['felder'][23] = 'd.funding_text';
        $this->old['fnamen'][23] = 'Finanzierung (TEXT)';
        $this->old['felder'][24] = 'bn1.login';
        $this->old['fnamen'][24] = 'Nutzerkennung 1';
        $this->old['felder'][25] = 'bn2.login';
        $this->old['fnamen'][25] = 'Nutzerkennung 2';
        $this->old['felder']['mnr'] = 'd.mnr';
        $this->old['fnamen']['mnr'] = 'Matrikelnummer';
        $this->old['felder']['viva_nr'] = 'd.viva_nr';
        $this->old['fnamen']['viva_nr'] = 'VIVA Nummer';
        $this->old['felder']['idm_pernr'] = 'd.idm_pernr';
        $this->old['fnamen']['idm_pernr'] = 'IDM Personalnummer';
        $this->old['felder']['reg_time'] = 'reg_time';
        $this->old['fnamen']['reg_time'] = 'Datum+Uhrzeit der Registrierung';

        $this->old['felder']['admineintrag'] = "d.admineintrag";
        $this->old['fnamen']['admineintrag'] = "Eintrag durch Admin";
        $bm = array('b', 'm1', 'm2', 'm3');
        for ($i = 0; $i < count($bm); $i++) {
            $this->old['felder']["$bm[$i]_anrede"] = "$bm[$i].anrede";
            $this->old['felder']["$bm[$i]_titel"] = "$bm[$i].titel";
            $this->old['felder']["$bm[$i]_vname"] = "$bm[$i].vname";
            $this->old['felder']["$bm[$i]_nname"] = "$bm[$i].nname";
            $this->old['felder']["$bm[$i]_email"] = "$bm[$i].email";
            $this->old['felder']["$bm[$i]_fakultaet"] = "$bm[$i].fakultaet";
            $this->old['felder']["$bm[$i]_lehrstuhl"] = "$bm[$i].lehrstuhl";
            $this->old['felder']["$bm[$i]_bestaetigt"] = "case when d.$bm[$i]_bestaetigt is null then 'Nein' else 'Ja' end";
            $this->old['felder']["$bm[$i]_id"] = "$bm[$i].id";
        }

        $res = pg_query($context->getDbConn(), 'select non_empty(de,en),id from baydoc_zulassungskat order by id');
        for ($i = 0; $i < pg_num_rows($res); $i++) {
            $r = pg_fetch_array($res, $i);
            if ($i == 0)
                $this->old['fgroup']["status_datum$i"] = 'Status-Infos';
            $this->old['felder']["status_datum$i"] = "baydoc_getstatus_date(d.id,$row1[id],$r[1])";

            $this->old['felder']["status_tage_seit$i"] = "now()::date-baydoc_getstatus_date(d.id,$row1[id],$r[1])";

        }
        $this->old['felder']["status_gs"] = "baydoc_gs_getstatus(d.id)";

        $docs = array('agreement', 'fast_track_datenblatt', 'zulassung', 'aufnahme', 'cv', 'motivation', 'abi', 'bachelor', 'diplom_master', 'good_academic_practice', 'add_pdf');
        $doc_names = array(
            'Betreuungsvereinbarung',
            'Fast Track Datenblatt',
            'Bescheinigung Fakultät über Erfüllung der Zulassungsvoraussetzungen',
            'Bescheinigung Graduiertenzentrum/-schule über Aufnahme',
            'Lebenslauf',
            'Motivationsschreiben',
            'letztes Schulzeugnis',
            'Nachweise Bachelorstudium',
            'Nachweise Masterstudium/Examen',
            'Zertifikat Gute Wissenschaftliche Praxis',
            'Zusatzdokumente'
        );
        $this->old['from'] = '';
        for ($i = 0; $i < count($docs); $i++) {
            if ($i == 0)
                $this->old['fgroup']["f_$docs[$i]_link"] = 'Dokumente';
            $this->old['felder']["f_$docs[$i]_link"] = "'<a href=\"../../intern/baydoc/get_file.php?id='||file$i.id||'\">PDF</a>'";
            $this->old['fnamen']["f_$docs[$i]_link"] = $doc_names[$i] . " (Download Link)";
            $this->old['felder']["f_$docs[$i]_time"] = "file$i.ts::date";
            $this->old['fnamen']["f_$docs[$i]_time"] = $doc_names[$i] . " (Änderungszeitpunkt)";
            $this->old['from'] .= " left outer join (select f.*,o.id_obj as id_stud,f.mtime as ts 
            from file f, objekt o where f.id=o.id and f.de='$docs[$i]') file$i on file$i.id_stud=d.id";
        }


        if ($row1['id'] == 5001) {
            $this->old['fgroup']["g_guthaben"] = "Finanzdaten";
            $this->old['felder']["g_guthaben"] = "baydoc_get_geld(d.id,null)";
            $this->old['fnamen']["g_guthaben"] = "Guthaben";
            $this->old['felder']["g_ausgaben"] = "baydoc_get_geld(d.id,1)";
            $this->old['fnamen']["g_ausgaben"] = "Ausgegeben";
            $this->old['felder']["g_gutschrift"] = "baydoc_get_geld(d.id,-1)";
            $this->old['fnamen']["g_gutschrift"] = "Gutschrift";
            $this->old['felder']["g_festlegung"] = "baydoc_get_geld(d.id,0)";
            $this->old['fnamen']["g_festlegung"] = "Festlegung";
            $this->old['felder']["g_link"] = "'<a href=\"../../admin/baydoc/index.php?id_obj='||d.id||'&tab=geld\">Details</a>'";
            $this->old['fnamen']["g_link"] = "Link zu Finanzdetails";

        }
        //Veranstaltungen
        $this->old['fgroup']["e_events"] = "Veranstaltungen";
        $this->old['felder']["e_events"] = "baydoc_get_event(d.id,'de')";
        $this->old['fnamen']["e_events"] = "Veranstaltungen (als Text)";
        $this->old['felder']["e_link"] = "'<a href=\"../../admin/baydoc/index.php?id_obj='||d.id||'&tab=event\">Details</a>'";
        $this->old['fnamen']["e_link"] = "Link zu Veranstaltungsdetails";

        //Publikationen
        $this->old['fgroup']["p_anz"] = "Publikationen";
        $this->old['felder']["p_anz"] = "baydoc_getpub_anz(d.id,true)";
        $this->old['fnamen']["p_anz"] = "Anzahl Publikationen bestätigt durch Betreuer";
        $this->old['felder']["p_pubs"] = "baydoc_getpubs(d.id,true)";
        $this->old['fnamen']["p_pubs"] = "Link zu Publikationen bestätigt durch Betreuer";
        $this->old['felder']["p_anz_total"] = "baydoc_getpub_anz(d.id,false)";
        $this->old['fnamen']["p_anz_total"] = "Anzahl Publikationen";
        $this->old['felder']["p_link"] = "'<a href=\"../../admin/baydoc/index.php?id_obj='||d.id||'&tab=pub\">Details</a>'";
        $this->old['fnamen']["p_link"] = "Link zu Publikationsdetails";

        //Uni-Abschluss
        $this->old['fgroup']['uni_land'] = 'Uni-Abschluss';
        $this->old['felder']['uni_land'] = 'd.uni_land';
        $this->old['fnamen']['uni_land'] = 'Land des Abschlusses';
        $this->old['felder']['uni_ort'] = 'd.uni_ort';
        $this->old['fnamen']['uni_ort'] = 'Ort des Abschlusses';
        $this->old['felder']['uni_name'] = 'd.uni_name';
        $this->old['fnamen']['uni_name'] = 'Name der Einrichtung';
        $this->old['felder']['uni_typ'] = 'd.uni_typ';
        $this->old['fnamen']['uni_typ'] = 'Einrichtungstyp';
        $this->old['felder']['uni_abschluss'] = 'd.uni_abschluss';
        $this->old['fnamen']['uni_abschluss'] = 'Abschluss';
        $this->old['felder']['uni_abschluss_name'] = 'd.uni_abschluss_name';
        $this->old['fnamen']['uni_abschluss_name'] = 'Name des Abschlusses';
        $this->old['felder']['uni_abschluss_datum'] = 'd.uni_abschluss_datum';
        $this->old['fnamen']['uni_abschluss_datum'] = 'Datum des Abschlusses';

        //Verfahren
        $this->old['fgroup']["zulassung_fach"] = "Verfahren";
        $this->old['felder']["zulassung_fach"] = "d.zulassung_fach";
        $this->old['fnamen']["zulassung_fach"] = "Zulassung Fach (alt)";
        $this->old['felder']["zulassung_stgfach"] = "d.zulassung_stgfach";
        $this->old['fnamen']["zulassung_stgfach"] = "Zulassung Studiengangsfach (alt)";
        $this->old['felder']["zulassung_promfach"] = "stg.name";
        $this->old['fnamen']["zulassung_promfach"] = "Promotionsfach";
        $this->old['felder']["zulassung_promfach_co"] = "non_empty(stg.co,stg.name)";
        $this->old['fnamen']["zulassung_promfach_co"] = "Promotionsfach (CO-Name)";
        $this->old['felder']["zulassung"] = "d.zulassung";
        $this->old['fnamen']["zulassung"] = "Datum Prüfung Zulassungsvoraussetzungen";
        $this->old['felder']["zulassung_text"] = "d.zulassung_text";
        $this->old['fnamen']["zulassung_text"] = "Zulassung Auflagen/Anmerkungen";
        $this->old['felder']["zulassung_antrag"] = "d.zulassung_antrag";
        $this->old['fnamen']["zulassung_antrag"] = "Datum Antrag Zulassung";
        $this->old['felder']["zulassung_zulassung"] = "d.zulassung_zulassung";
        $this->old['fnamen']["zulassung_zulassung"] = "Datum Annahme zur Promotion";
        $this->old['felder']["zulassung_promordnung"] = "d.zulassung_promordnung";
        $this->old['fnamen']["zulassung_promordnung"] = "Promotionsordnung";
        $this->old['felder']["zulassung_ueberpruefung"] = "d.zulassung_ueberpruefung";
        $this->old['fnamen']["zulassung_ueberpruefung"] = "Bemerkung Überprüfungsergebnis";
        $this->old['felder']["proverein"] = "d.proverein";
        $this->old['fnamen']["proverein"] = "Datum Betreuungsvereinbarung";
        $this->old['felder']["proverein_text"] = "d.proverein_text";
        $this->old['fnamen']["proverein_text"] = "Auflagen/Anmerkungen Betreuungsvereinbarung";
        $this->old['felder']["prue_antrag"] = "d.prue_antrag";
        $this->old['fnamen']["prue_antrag"] = "Datum „Zulassung zum Promotionsprüfungsverfahren“";
        $this->old['felder']["prue_abgabe"] = "d.prue_abgabe";
        $this->old['fnamen']["prue_abgabe"] = "Datum Abgabe der Arbeit";
        $this->old['felder']["prue_titel"] = "d.prue_titel";
        $this->old['fnamen']["prue_titel"] = "Titel der Arbeit";
        $this->old['felder']["prue_prom_komm"] = "d.prue_prom_komm";
        $this->old['fnamen']["prue_prom_komm"] = "Datum der Promotionskommission";
        $this->old['felder']["prue_zulassung"] = "d.prue_zulassung";
        $this->old['fnamen']["prue_zulassung"] = "Zulassung zum Promotionsprüfungsverfahren";
        $this->old['felder']["prue_gut1"] = "gut1.vname||' '||gut1.nname";
        $this->old['fnamen']["prue_gut1"] = "Name Gutachter*in 1";
        $this->old['felder']["prue_best_gut1"] = "d.prue_best_gut1";
        $this->old['fnamen']["prue_best_gut1"] = "Bestellung Gutachter*innen 1 und Versand der Druckexemplare";
        $this->old['felder']["prue_ein_gut1"] = "d.prue_ein_gut1";
        $this->old['fnamen']["prue_ein_gut1"] = "Eingang Gutachten 1";
        $this->old['felder']["prue_gut2"] = "gut2.vname||' '||gut2.nname";
        $this->old['fnamen']["prue_gut2"] = "Name Gutachter*in 2";
        $this->old['felder']["prue_best_gut2"] = "d.prue_best_gut2";
        $this->old['fnamen']["prue_best_gut2"] = "Bestellung Gutachter*innen 2 und Versand der Druckexemplare";
        $this->old['felder']["prue_ein_gut2"] = "d.prue_ein_gut2";
        $this->old['fnamen']["prue_ein_gut2"] = "Eingang Gutachten 2";
        $this->old['felder']["prue_gutw"] = "gutw.vname||' '||gutw.nname";
        $this->old['fnamen']["prue_gutw"] = "Name weitere Gutachter*in";
        $this->old['felder']["prue_best_gutw"] = "d.prue_best_gutw";
        $this->old['fnamen']["prue_best_gutw"] = "Bestellung weiterer Gutachter*innen";
        $this->old['felder']["prue_ein_gutw"] = "d.prue_ein_gutw";
        $this->old['fnamen']["prue_ein_gutw"] = "Eingang weitere Gutachten";
        $this->old['felder']["prue_aus_start"] = "d.prue_aus_start";
        $this->old['fnamen']["prue_aus_start"] = "Beginn der Auslagefrist";
        $this->old['felder']["prue_aus_end"] = "d.prue_aus_end";
        $this->old['fnamen']["prue_aus_end"] = "Ende der Auslagefrist";
        $this->old['felder']["prue_mit_koll"] = "d.prue_mit_koll";
        $this->old['fnamen']["prue_mit_koll"] = "Mitteilung des Kolloquium-Termins";
        $this->old['from'] .= " left outer join bayprof gut1 on gut1.id=d.prue_gut1_id
                   left outer join bayprof gut2 on gut2.id=d.prue_gut2_id
                   left outer join bayprof gutw on gutw.id=d.prue_gutw_id";

        $this->old['felder']["prue_pruef"] = "d.prue_pruef";
        $this->old['fnamen']["prue_pruef"] = "voraussichtliches Datum der mündlichen Prüfung";
        $this->old['felder']["prue_pflicht"] = "d.prue_pflicht";
        $this->old['fnamen']["prue_pflicht"] = "Datum Abgabe Pflichtexemplare";
        $this->old['felder']["prue_urkunde"] = "d.prue_urkunde";
        $this->old['fnamen']["prue_urkunde"] = "Datum der mündlichen Prüfung";
        $this->old['felder']["prue_urkunde2"] = "d.prue_urkunde2";
        $this->old['fnamen']["prue_urkunde2"] = "Datum der Urkunde";
        $this->old['felder']["prue_eref"] = "d.prue_eref";
        $this->old['fnamen']["prue_eref"] = "eRef-Link";
        $this->old['felder']["prue_urkunde_aus"] = "d.prue_urkunde_aus";
        $this->old['fnamen']["prue_urkunde_aus"] = "Datum der Aushändigung der Urkunde";
        $this->old['felder']["prue_erhebung_frei"] = "d.prue_erhebung_frei";
        $this->old['fnamen']["prue_erhebung_frei"] = "Datum Erhebungsbogen freigegeben";
        $this->old['felder']["prue_erhebung_bearb"] = "d.prue_erhebung_bearb";
        $this->old['fnamen']["prue_erhebung_bearb"] = "Datum Erhebungsbogen bearbeitet";


        $this->old['felder']["prue_note"] = "d.prue_note";
        $this->old['fnamen']["prue_note"] = "Gesamtnote";


        $this->old['felder']["uniwechsel"] = "d.uniwechsel";
        $this->old['fnamen']["uniwechsel"] = "Datum Uniwechsel";
        $this->old['felder']["uniwechsel_text"] = "d.uniwechsel_text";
        $this->old['fnamen']["uniwechsel_text"] = "Ziel-Uni";
        $this->old['felder']["abbruch"] = "d.abbruch";
        $this->old['fnamen']["abbruch"] = "Datum Rücktritt";
        $this->old['felder']["abbruch_text"] = "d.abbruch_text";
        $this->old['fnamen']["abbruch_text"] = "Anmerkungen Rücktritt";
        $this->old['felder']["abbruch_best"] = "d.abbruch_best";
        $this->old['fnamen']["abbruch_best"] = "Datum „Bestätigung Rücktritt von der Promotion“";


        //Statistik-Formular
        $this->old['fgroup']["stat_mnr"] = "Statistik-Felder";
        $this->old['felder']["stat_mnr"] = "to_char(d.mnr,' 99999999999')";
        $this->old['fnamen']["stat_mnr"] = "Matrikel Nummer (mit führenden Lehrzeichen)";
        $this->old['fnamen']["stat_xmann"] = "X falls Mann";
        $this->old['felder']["stat_xmann"] = "case when d.anrede='Herr' then 'X' end";
        $this->old['fnamen']["stat_xfrau"] = "X falls Frau";
        $this->old['felder']["stat_xfrau"] = "case when d.anrede!='Herr' then 'X' end";
        $this->old['felder']["stat_gmonat"] = "to_char(d.gdatum,'MM')";
        $this->old['fnamen']["stat_gmonat"] = "Geburtsmonat";
        $this->old['felder']["stat_gjahr"] = "to_char(d.gdatum,'YYYY')";
        $this->old['fnamen']["stat_gjahr"] = "Geburtsjahr";
        $this->old['felder']["stat_xdeutsch"] = "case when d.land='Deutschland' or d.land2='Deutschland' then 'X' end";
        $this->old['fnamen']["stat_xdeutsch"] = "X falls Deutschland";
        $this->old['felder']["stat_land"] = "case when d.land!='Deutschland' and (d.land2!='Deutschland' or d.land2 is null) then d.land end";
        $this->old['fnamen']["stat_land"] = "Nationalität falls nicht Deutschland";
        $this->old['felder']["stat_land_nr"] = "case when d.land!='Deutschland' and (d.land2!='Deutschland' or d.land2 is null) then (select schluessel from stat_laender where name=d.land) end";
        $this->old['fnamen']["stat_land_nr"] = "Nationalität Nummer falls nicht Deutschland";
        $this->old['felder']["stat_semester"] = "to_char(ceil((d.prue_urkunde-(".$this->sql_ef13_date."))::float/365*2),'09')";
        $this->old['fnamen']["stat_semester"] = "Anzahl Fachsemester";
        /* $this->old['felder']["stat_fach"]="(select g.name from baydoc_fach f, baydoc_faecher g where f.name=d.zulassung_fach and f.kennung_fg=g.kennung)";
        $this->old['fnamen']["stat_fach"]="Fächergruppe";
        $this->old['felder']["stat_fach_nr"]="(select kennung_fg from baydoc_fach where name=d.zulassung_fach)";
        $this->old['fnamen']["stat_fach_nr"]="Fächergruppe Kennung";*/
        $this->old['felder']["stat_stgfach"] = "stg.name";
        $this->old['fnamen']["stat_stgfach"] = "Studiengang Fach";
        $this->old['felder']["stat_stgfach_nr"] = "stg.signatur";
        $this->old['fnamen']["stat_stgfach_nr"] = "Studiengang Kennung Fach";
        $this->old['felder']["stat_stgfachgruppe"] = "stg_gr.name";
        $this->old['fnamen']["stat_stgfachgruppe"] = "Studiengang Fächergruppe";
        $this->old['felder']["stat_stgfachgruppe_nr"] = "stg.signatur_gr";
        $this->old['fnamen']["stat_stgfachgruppe_nr"] = "Studiengang Kennung Fächergruppe";
        $this->old['felder']["stat_prom_art"] = "case when d.zulassung_prom_art>'' then d.zulassung_prom_art else '506' end";
        $this->old['fnamen']["stat_prom_art"] = "Art der Promotion";
        $this->old['felder']["stat_monat"] = "to_char(d.prue_urkunde,'MM')";
        $this->old['fnamen']["stat_monat"] = "Abschlussmonat";
        $this->old['felder']["stat_jahr"] = "to_char(d.prue_urkunde,'YYYY')";
        $this->old['fnamen']["stat_jahr"] = "Abschlussjahr";
        $this->old['felder']["stat_x0"] = "case when d.prue_note=0 then 'X' end";
        $this->old['fnamen']["stat_x0"] = "X falls Note 0";
        $this->old['felder']["stat_x1"] = "case when d.prue_note=1 then 'X' end";
        $this->old['fnamen']["stat_x1"] = "X falls Note 1";
        $this->old['felder']["stat_x2"] = "case when d.prue_note=2 then 'X' end";
        $this->old['fnamen']["stat_x2"] = "X falls Note 2";
        $this->old['felder']["stat_x3"] = "case when d.prue_note=3 then 'X' end";
        $this->old['fnamen']["stat_x3"] = "X falls Note 3";
        $this->old['felder']["stat_x4"] = "case when d.prue_note=4 then 'X' end";
        $this->old['fnamen']["stat_x4"] = "X falls Note 4";


        $this->old['fgroup']["hstatg_emnr"] = "HStatG-Felder";
        $this->old['felder']["hstatg_emnr"] = "d.hstatg_meldenummer";
        $this->old['fnamen']["hstatg_emnr"] = "Erstmeldenummer";
        $this->old['felder']["hstatg_no"] = "d.no_hstatg";
        $this->old['fnamen']["hstatg_no"] = "Datensatz von HStatG-Meldung ausschließen";
        for ($y = 2017; $y <= min(date('Y') - 1, 2027); $y++) {
            $this->old['felder']["hstatg$y"] = "d.hstatg$y";
            $this->old['fnamen']["hstatg$y"] = "Paginiernummer Meldung $y";
        }
        $this->old['felder']['hstatg_mp_date'] = "d.hstatg_mp_date";
        $this->old['fnamen']['hstatg_mp_date'] = "Prüfungsstatistik Meldung";
        $this->old['felder']['hstatg_mp_nummer'] = "d.hstatg_mp_nummer";
        $this->old['fnamen']['hstatg_mp_nummer'] = "Prüfungsstatistik Paginiernummer";


        $this->old['felder']["hstatg_id"] = "'05100000'";
        $this->old['fnamen']["hstatg_id"] = "Berichtseinheitid - fix 05100000";
        $this->old['felder']["hstatg_ef01"] = "'09'";
        $this->old['fnamen']["hstatg_ef01"] = "Berichtsland (EF01) - fix 09";
        $this->old['felder']["hstatg_ef02"] = "to_char(now()-interval '9 months','YYYY')";
        $this->old['fnamen']["hstatg_ef02"] = "Berichtsjahr (EF02)";
        $this->old['felder']["hstatg_ef03"] = "case when non_empty(pl.de,pl.en) ilike '%VII' then '0511' else '0510' end";
        $this->old['fnamen']["hstatg_ef03"] = "Hochschule der Promotion (EF03) - 0510/0511";
        $this->old['felder']["hstatg_ef04"] = " to_char(row_number() OVER (order by d.id),'000000')";
        $this->old['fnamen']["hstatg_ef04"] = "Paginiernummer (EF04)";


        $this->old['felder']["hstatg_geschlecht"] = "d.hstatg_geschlecht";
        $this->old['fnamen']["hstatg_geschlecht"] = "Geschlecht (EF05)";
        $this->old['felder']["hstatg_geburt"] = "to_char(d.gdatum,'DDMMYYYY')";
        $this->old['fnamen']["hstatg_geburt"] = "Geburtsdatum (EF06)";
        $this->old['felder']["hstatg_ef06u1"] = "to_char(d.gdatum,'DD')";
        $this->old['fnamen']["hstatg_ef06u1"] = "Geburtsdatum (EF06U1)";
        $this->old['felder']["hstatg_ef06u2"] = "to_char(d.gdatum,'MM')";
        $this->old['fnamen']["hstatg_ef06u2"] = "Geburtsdatum (EF06U2)";
        $this->old['felder']["hstatg_ef06u3"] = "to_char(d.gdatum,'YYYY')";
        $this->old['fnamen']["hstatg_ef06u3"] = "Geburtsdatum (EF06U3)";
        $this->old['felder']["hstatg_vname"] = "rpad(baydoc_sonderzeichen2txt(d.vorname),4)";
        $this->old['fnamen']["hstatg_vname"] = "Vorname - 4 Zeichen (EF07)";
        $this->old['felder']["hstatg_staat"] = "staat1.schluessel";
        $this->old['fnamen']["hstatg_staat"] = "Staatsangehörigkeit (EF08)";
        $this->old['felder']["hstatg_staat2"] = "case when staat2.schluessel!=staat1.schluessel then staat2.schluessel end";
        $this->old['fnamen']["hstatg_staat2"] = "Weitere Staatsangehörigkeit (EF09)";


        $this->old['felder']["hstatg_prom_art"] = "d.hstatg_prom_art";
        $this->old['fnamen']["hstatg_prom_art"] = "Art der Promotion (EF10)";
        $this->old['felder']["hstatg_prom_art_01"] = "case when d.hstatg_prom_art is null then '01' else d.hstatg_prom_art end";
        $this->old['fnamen']["hstatg_prom_art_01"] = "Art der Promotion - default 01 (EF10)";
        $this->old['felder']["hstatg_prom_fach"] = "stg.signatur";
        $this->old['fnamen']["hstatg_prom_fach"] = "Promotionsfach (EF11)";

        $this->old['felder']["hstatg_ef12"] = "case when d.abbruch_best<='" . $this->hstatg_2024_ende . "' or d.abbruch<='" . $this->hstatg_2024_ende . "' then 6
when d.prue_urkunde is not null and d.prue_urkunde<='" . $this->hstatg_2024_ende . "' then 5
when d.prue_nichtbestanden is not null and d.prue_nichtbestanden<='" . $this->hstatg_2024_ende . "' then 5
when d.pstart2<'" . $this->hstatg_2024_start . "' and d.pstart2>('" . $this->hstatg_2024_start . "'::date-interval '1 year') then 2
when " . $this->sql_ef13_date . "<'" . $this->hstatg_2024_start . "' then 3
else 1 end";
        $this->old['fnamen']["hstatg_ef12"] = "Art der Registrierung als Promovierender (EF12)";
        $this->old['felder']["hstatg_prom_start"] = "to_char(" . $this->sql_ef13_date . ",'MMYYYY')";
        $this->old['fnamen']["hstatg_prom_start"] = "Promotionsbeginn (EF13) (Minimum aus ...)";
        $this->old['felder']["hstatg_prom_start_gemeldet"] = "d.hstatg_ef13";
        $this->old['fnamen']["hstatg_prom_start_gemeldet"] = "Promotionsbeginn (EF13) gemeldet";
        $this->old['felder']["hstatg_ef13u1"] = "to_char(" . $this->sql_ef13_date . ",'MM')";
        $this->old['fnamen']["hstatg_ef13u1"] = "Promotionsbeginn (EF13U1)";
        $this->old['felder']["hstatg_ef13u2"] = "to_char(" . $this->sql_ef13_date . ",'YYYY')";
        $this->old['fnamen']["hstatg_ef13u2"] = "Promotionsbeginn (EF13U2)";
        $this->old['felder']["hstatg_prom_ende"] = "to_char(case when " . $this->sql_ef14_date . "<='" . $this->hstatg_2024_ende . "'
then " . $this->sql_ef14_date . " end,'MMYYYY')";
        $this->old['fnamen']["hstatg_prom_ende"] = "Ende der Promotion (EF14) == Verfahren Datum der mündlichen Prüfung oder Datum „Bestätigung Rücktritt von der Promotion“";
        $this->old['felder']["hstatg_prom_ende_gemeldet"] = "d.hstatg_ef14";
        $this->old['fnamen']["hstatg_prom_ende_gemeldet"] = "Promotionsende (EF14) gemeldet";
        $this->old['felder']["hstatg_ef14u1"] = "to_char(case when " . $this->sql_ef14_date . "<='" . $this->hstatg_2024_ende . "'
then " . $this->sql_ef14_date . " end,'MM')";
        $this->old['fnamen']["hstatg_ef14u1"] = "Ende der Promotion (EF14U1)";
        $this->old['felder']["hstatg_ef14u2"] = "to_char(case when " . $this->sql_ef14_date . "<='" . $this->hstatg_2024_ende . "'
then " . $this->sql_ef14_date . " end,'YYYY')";
        $this->old['fnamen']["hstatg_ef14u2"] = "Ende der Promotion (EF14U2)";
        $this->old['felder']["hstatg_immatrikuliert"] = "case when d.hstatg_immatrikuliert then 1 else 0 end";
        $this->old['fnamen']["hstatg_immatrikuliert"] = "Immatrikulation (EF15)";
        $this->old['felder']["hstatg_pprog"] = "case when d.hstatg_promprog then '1' else '0' end";
        $this->old['fnamen']["hstatg_pprog"] = "Teilnahme an einem strukturierten Promotionsprogramm (EF16)";
        $this->old['felder']["hstatg_beschaeftigt"] = "case when d.hstatg_beschaeftigt then 1 else 0 end";
        $this->old['fnamen']["hstatg_beschaeftigt"] = "Beschäftigungsverhältnis an der Hochschule der Promotion (EF17)";
        $this->old['felder']["hstatg_diss_art"] = "d.hstatg_diss_art::int";
        $this->old['fnamen']["hstatg_diss_art"] = "Art der Dissertation (EF18)";
        $this->old['felder']["hstatg_diss_art_01"] = "case when d.hstatg_diss_art is null then 1 else d.hstatg_diss_art::int end";
        $this->old['fnamen']["hstatg_diss_art_01"] = "Art der Dissertation - default 1 (EF18)";
        $this->old['felder']["hstatg_ehs"] = "ehs.schluessel";
        $this->old['fnamen']["hstatg_ehs"] = "Hochschule (EF19)";
        $this->old['felder']["hstatg_ehs_land"] = "case when ehs_land.schluessel!='000' then ehs_land.schluessel end";
        $this->old['fnamen']["hstatg_ehs_land"] = "Staat der HS (EF20)";
        $this->old['felder']["hstatg_ehs_semester"] = "d.hstatg_erst_semester";
        $this->old['fnamen']["hstatg_ehs_semester"] = "Semester (EF21)";
        $this->old['felder']["hstatg_ehs_jahr"] = "d.hstatg_erst_jahr";
        $this->old['fnamen']["hstatg_ehs_jahr"] = "Jahr der Ersteinschreibung (EF22)";
        $this->old['felder']["hstatg_ehs_monat"] = "d.hstatg_erst_monat";
        $this->old['fnamen']["hstatg_ehs_monat"] = "Monat der Ersteinschreibung";
        //  $this->old['felder']["hstatg_start_bachelor"]="d.hstatg_start_bachelor";
//  $this->old['fnamen']["hstatg_start_bachelor"]="Start Bachelor Studium";
        $this->old['felder']["hstatg_end_bachelor"] = "d.hstatg_end_bachelor";
        $this->old['fnamen']["hstatg_end_bachelor"] = "Datum des Zeugnisses (Bachelor)";

        $this->old['felder']["hstatg_ef23"] = "1";
        $this->old['fnamen']["hstatg_ef23"] = "Zur Promotion berechtigende Abschlussprüfung wurde/wurde noch nicht abgelegt (EF23) - fix 1";
        $this->old['felder']["hstatg_ahs"] = "ahs.schluessel";
        $this->old['fnamen']["hstatg_ahs"] = "Hochschule (EF24)";
        $this->old['felder']["hstatg_ahs_land"] = "case when ahs_land.schluessel!='000' then ahs_land.schluessel end";
        $this->old['fnamen']["hstatg_ahs_land"] = "Staat der HS (EF25)";
        $this->old['felder']["hstatg_ahs_art"] = "replace(ahs_art.schluessel,' ','')";
        $this->old['fnamen']["hstatg_ahs_art"] = "Art der Prüfung (EF26)";
        $this->old['felder']["hstatg_ahs_fach"] = "ahs_fach.signatur";
        $this->old['fnamen']["hstatg_ahs_fach"] = "1. Studienfach (EF27)";
        $this->old['felder']["hstatg_ahs_monat"] = "to_char(d.hstatg_ab_datum,'MM')";
        $this->old['fnamen']["hstatg_ahs_monat"] = "Monat des Abschlusses (EF28)";
        $this->old['felder']["hstatg_ahs_jahr"] = "to_char(d.hstatg_ab_datum,'YYYY')";
        $this->old['fnamen']["hstatg_ahs_jahr"] = "Jahr des Abschlusses (EF29)";
        $this->old['felder']["hstatg_ahs_note"] = "substr(d.hstatg_ab_note,2,1)";
        $this->old['fnamen']["hstatg_ahs_note"] = "Gesamtnote des Abschlusses (EF30)";
        $this->old['felder']["hstatg_start_master_monat"] = "d.hstatg_start_master_monat";
        $this->old['fnamen']["hstatg_start_master_monat"] = "Start Master Studium Monat";
        $this->old['felder']["hstatg_start_master_jahr"] = "d.hstatg_start_master_jahr";
        $this->old['fnamen']["hstatg_start_master_jahr"] = "Start Master Studium Jahr";
        $this->old['felder']["hstatg_master_degree"] = "d.master_degree_grade";
        $this->old['fnamen']["hstatg_master_degree"] = "Master Note (numerisch)";
        $this->old['felder']["hstatg_master_min"] = "d.master_degree_min";
        $this->old['fnamen']["hstatg_master_min"] = "Schlechteste Masternote im Studiensystem";
        $this->old['felder']["hstatg_master_max"] = "d.master_degree_max";
        $this->old['fnamen']["hstatg_master_max"] = "Beste Masternote im Studiensystem";
        $this->old['felder']["hstatg_master_degree_equiv"] = "d.master_degree_grade_equiv";
        $this->old['fnamen']["hstatg_master_degree_equiv"] = "Äquivalentnote (bayerische Formel)";



        $this->old['felder']["hstatg_hzb_jahr"] = "d.hstatg_hzb_jahr";
        $this->old['fnamen']["hstatg_hzb_jahr"] = "Jahr des ersten Erwerbs einer HZB (EF31)";
        $this->old['felder']["hstatg_hzb_art"] = "hzb.schluessel";
        $this->old['fnamen']["hstatg_hzb_art"] = "Art der ersten HZB (EF32)";
        $this->old['felder']["hstatg_hzb_kreis"] = "hzb_kreis.schluessel";
        $this->old['fnamen']["hstatg_hzb_kreis"] = "Ort (EF33)";
        $this->old['felder']["hstatg_hzb_land"] = "hzb_land.schluessel";
        $this->old['fnamen']["hstatg_hzb_land"] = "Wenn HZB im Ausland erworben: Land (EF33)";
        $this->old['felder']["hstatg_ef33U1"] = "case when hzb_kreis.schluessel is null then case when hzb_land.schluessel!='000' then '99' end else substring(hzb_kreis.schluessel from 1 for 2) end";
        $this->old['fnamen']["hstatg_ef33U1"] = "Bundesland (EF33U1)";
        $this->old['felder']["hstatg_ef33U2"] = "case when hzb_kreis.schluessel is null then hzb_land.schluessel else replace(substring(hzb_kreis.schluessel from 3 for 7),' ','') end";
        $this->old['fnamen']["hstatg_ef33U2"] = "Kreis/Land (EF33U2)";



        $this->old['felder']["hstatg_hzb_ok"] = "non_empty((((hzb_land.schluessel='000' and hzb_kreis.schluessel>'') 
or (hzb_land.schluessel is not null and hzb_land.schluessel!='000')) 
and d.hstatg_hzb_jahr>1920 and d.hstatg_hzb_jahr<extract(year from now())
and hzb.schluessel>'')::text,'f')::boolean ";
        $this->old['fnamen']["hstatg_hzb_ok"] = "HZB vollständig";
        $this->old['felder']["hstatg_erst_ok"] = "non_empty((
ehs.schluessel>'' and ehs_land.schluessel>'' and d.hstatg_erst_semester>'' and d.hstatg_erst_jahr>1920 and d.hstatg_erst_jahr<extract(year from now())
)::text,'f')::boolean";
        $this->old['fnamen']["hstatg_erst_ok"] = "Ersteinschreibung vollständig";
        $this->old['felder']["hstatg_ab_ok"] = "non_empty((
ahs.schluessel>'' and ahs_land.schluessel>'' and ahs_art.schluessel>'' and ahs_fach.signatur>'' and d.hstatg_ab_datum is not null and d.hstatg_ab_note>''
)::text,'f')::boolean";
        $this->old['fnamen']["hstatg_ab_ok"] = "Abschlussprüfung vollständig";
        $this->old['felder']["hstatg_ok"] = "d.hstatg_ok";
        $this->old['fnamen']["hstatg_ok"] = "Ausbildungstab geprüft und gesprerrt (ausländische Ausbildungsabschnitte durch Incoming Degree, sonst Graduate School)";
        $this->old['felder']["hstatg_abgleich"] = "d.hstatg_abgleich";
        $this->old['fnamen']["hstatg_abgleich"] = "HStatG-Abgleich";

        $this->old['felder']["stat_ahs_typ"] = "ahs.typ";
        $this->old['fnamen']["stat_ahs_typ"] = "Art der Hochschule";
        $this->old['fgroup']['stat_ahs_typ'] = 'Hochschulabschluss';
        $this->old['felder']["stat_ahs_name"] = "ahs.name";
        $this->old['fnamen']["stat_ahs_name"] = "Name der Hochschule";
        $this->old['felder']["stat_ahs_stadt"] = "ahs.stadt";
        $this->old['fnamen']["stat_ahs_stadt"] = "Stadt";
        $this->old['felder']["stat_ahs_bundesland"] = "ahs.bundesland";
        $this->old['fnamen']["stat_ahs_bundesland"] = "Bundesland";

        $this->old['felder']["stat_ehs_typ"] = "ehs.typ";
        $this->old['fnamen']["stat_ehs_typ"] = "Art der Hochschule";
        $this->old['fgroup']['stat_ehs_typ'] = 'Hochschule der Ersteinschreibung';
        $this->old['felder']["stat_ehs_name"] = "ehs.name";
        $this->old['fnamen']["stat_ehs_name"] = "Name der Hochschule";
        $this->old['felder']["stat_ehs_stadt"] = "ehs.stadt";
        $this->old['fnamen']["stat_ehs_stadt"] = "Stadt";
        $this->old['felder']["stat_ehs_bundesland"] = "ehs.bundesland";
        $this->old['fnamen']["stat_ehs_bundesland"] = "Bundesland";



        $this->old['fgroup']["hstatg_admin_hzb_zeugnis"] = "Admin HStatG-Felder";
        $this->old['felder']["hstatg_admin_hzb_zeugnis"] = "d.admin_hzb_zeugnis";
        $this->old['fnamen']["hstatg_admin_hzb_zeugnis"] = "Prüfung HZB";
        $this->old['felder']["hstatg_admin_bachelor_zeugnis"] = "d.admin_bachelor_zeugnis";
        $this->old['fnamen']["hstatg_admin_bachelor_zeugnis"] = "Prüfung Bachelor";
        $this->old['felder']["hstatg_admin_master_zeugnis"] = "d.admin_master_zeugnis";
        $this->old['fnamen']["hstatg_admin_master_zeugnis"] = "Prüfung Master";
        $this->old['felder']["hstatg_admin_cv"] = "d.admin_cv";
        $this->old['fnamen']["hstatg_admin_cv"] = "Prüfung CV";
        $this->old['felder']["hstatg_admin_add"] = "d.admin_add";
        $this->old['fnamen']["hstatg_admin_add"] = "Prüfung Zusatzupload";
        $this->old['felder']["hstatg_admin_bigsas"] = "d.admin_bigsas";
        $this->old['fnamen']["hstatg_admin_bigsas"] = "Prüfung BIGSAS";


        $qb = new \BayDOC\QB\Doc($context);
        $sql_hash = [];
        $name_hash = [];
        $maps = [];
        foreach ($qb->getFields() as $f) {
            $sql_hash[$f->name] = $f->getSQL('t.','order');
            $name_hash[$f->name] = $f->getDescription(false);
        }

        $sql_hash_manual = [
            'd.land' => 'nat1.name',
            'd.land2' => 'nat2.name',
            "baydoc_get_event(d.id,'')" => "baydoc_get_event(d.id,'de')",
            "non_empty(pl.de,pl.en)" =>'fak.de',
            "non_empty(l.de,l.en)" =>'prom_prog.de'
        ];

        foreach ($this->old['felder'] as $key => $value) {
            if (isset($sql_hash_manual[$value])) {
                $value = $sql_hash_manual[$value];
            } else $value = $this->old2new($value);
            $keys=array_keys($sql_hash,$value);
            foreach($keys as $name){
                $this->field_map[$key] = $name;
                $maps[$name] = 1;
            }
        }

        foreach ($this->old['fnamen'] as $key => $value) {
            if (($name = array_search($value, $name_hash)) === false)
                continue;
            $this->field_map[$key] = $name;
            $maps[$name] = 1;
        }

        /*
                echo '<h3>Nicht zugeordnete Felder</h3>';
                foreach ($this->old['felder'] as $key => $value) {
                    if (!isset($this->field_map[$key]))
                        echo "$key => $value<br/>";
                }

                echo '<h3>Felder ohne Entsprechung</h3>';
                foreach ($sql_hash as $key => $value) {
                    if (!isset($maps[$key]))
                        echo "$key => $value<br/>";
                }

                echo "<pre>";
                //print_r($this->old['felder']);
                //print_r($sql_hash);
                //print_r($this->old['fnamen']);

                //print_r($name_hash);
                print_r($this->field_map);
                print_r($this->prefilter_map);
                echo "</pre>";
        */
    }






}