<?php

namespace BayDOC\QB\Mapper;

class Event extends Base
{
    protected $table_hash = [
        't' => 'e',
        'd' => 'h'
    ];
    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        parent::__construct($context, 1);
        $this->old['fgroup']['id'] = "Teilnehmer";
        $felder = explode(',', 'id,titel,anrede,name,vorname,gname,gdatum,gort,str,ort,land_wohnort,land,land2,tel,email,homepage,antrag');
        $this->old['felder'] = array();
        $this->old['fnamen'] = array();
        for ($i = 0; $i < count($felder); $i++) {
            $this->old['felder'][$felder[$i]] = 'h.' . $felder[$i];
        }
        $this->old['felder']['einheit'] = "non_empty(l.de,l.en)";
        $this->old['felder']['obereinheit'] = "non_empty(pl.de,pl.en)";
        $this->old['fnamen']['einheit'] = "Einheit";
        $this->old['fnamen']['obereinheit'] = "Obereinheit";
        $this->old['felder']['gruppe'] = 'h.gruppe';
        $this->old['fnamen']['gruppe'] = 'Gruppe';
        $this->old['felder']['link'] = "'<a href=\"../../admin/'||h.gruppe||'/index.php?id_obj='||h.id||'\">Details</a>'";
        $this->old['fnamen']['link'] = 'Link';
        $this->old['fgroup']['e_name'] = "Veranstaltung";
        $this->old['felder']['e_name'] = "non_empty(".$context->getLangLang2('e.').")";
        $this->old['fnamen']['e_name'] = "Name";
        $this->old['felder']['e_de'] = "e.de";
        $this->old['fnamen']['e_de'] = "Name (deutsch)";
        $this->old['felder']['e_text_de'] = "e.text_de";
        $this->old['fnamen']['e_text_de'] = "Beschreibung (deutsch)";
        $this->old['felder']['e_datum'] = "e.datum";
        $this->old['fnamen']['e_datum'] = "Datum";
        $this->old['felder']['e_datum_bis'] = "e.datum_bis";
        $this->old['fnamen']['e_datum_bis'] = "bis Datum";
        $this->old['felder']['e_von'] = "e.von";
        $this->old['fnamen']['e_von'] = "Uhrzeit von";
        $this->old['felder']['e_bis'] = "e.bis";
        $this->old['fnamen']['e_bis'] = "Uhrzeit bis";
        $this->old['felder']['e_id'] = "e.id";
        $this->old['fnamen']['e_id'] = "ID";
        $this->old['felder']['e_anmeldung'] = "e.anmeldung_bis";
        $this->old['fnamen']['e_anmeldung'] = "Anmeldung bis";
        $this->old['felder']['e_max_anzahl'] = "e.max_anzahl";
        $this->old['fnamen']['e_max_anzahl'] = "Maximale Anzahl";
        $this->old['felder']['e_min_geld'] = "e.min_geld";
        $this->old['fnamen']['e_min_geld'] = "Minimales Guthaben";
        $this->old['felder']['e_kat'] = "non_empty(".$context->getLangLang2('gk.').")";
        $this->old['fnamen']['e_kat'] = "Geld-Kategorie";



        $qb = new \BayDOC\QB\Event($context);
        $sql_hash = [];
        $maps = [];
        foreach ($qb->getFields() as $f) {
            $sql_hash[$f->name] = $f->getSQL('t.','order');
        }

        $sql_hash_manual = [
            "non_empty(pl.de,pl.en)" =>'fak.de',
            "non_empty(l.de,l.en)" =>'prom_prog.de',
        ];
        foreach ($this->old['felder'] as $key => $value) {
            if (isset($sql_hash_manual[$value])) {
                $value = $sql_hash_manual[$value];
            } else
                $value = $this->old2new($value);
            $keys = array_keys($sql_hash, $value);
            foreach ($keys as $name) {
                $this->field_map[$key] = $name;
                $maps[$name] = 1;
            }
        }



    }

}