<?php

namespace BayDOC\QB\Mapper;

class Events extends Base
{
    protected $table_hash = [
        't' => 'e'
    ];
    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        parent::__construct($context, 1);
        $fnr = [
            'e.id',
            'e.de',
            'e.en',
            'e.url',
            'e.datum',
            'e.datum_bis',
            'e.von',
            'e.bis',
            'e.anmeldung_bis',
            'e.max_anzahl',
            'e.min_geld',
            'e.id_gkat',
            'e.postdoc',
            'e.baydoc',
            'e.waitlist'
        ];
        $this->old['felder'] = array_combine($fnr, $fnr);
        $this->old['felder']['current'] = "a.count";
        $this->old['felder']['waitlist'] = "w.count";

        $qb = new \BayDOC\QB\Events($context);
        $sql_hash = [];
        $maps = [];
        foreach ($qb->getFields() as $f) {
            $sql_hash[$f->name] = $f->getSQL('t.', 'order');
        }

        $sql_hash_manual = [
        ];
        foreach ($this->old['felder'] as $key => $value) {
            if (isset($sql_hash_manual[$value])) {
                $value = $sql_hash_manual[$value];
            } else
                $value = $this->old2new($value);
            $keys = array_keys($sql_hash, $value);
            foreach ($keys as $name) {
                $this->field_map[$key] = $name;
                $maps[$name] = 1;
            }
        }



    }

}