<?php

namespace BayDOC\QB\Mapper;

class Postdoc extends Base
{
    protected $table_hash = [
        't' => 'h',
        'geld' => 'b',
        'prof_b' => 'p',
        'prof_m1' => 'm1',
        'prof_m2' => 'm2',
        'prof_m3' => 'm3',
        'user1' => 'b1',
        'user2' => 'b2',
    ];

    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        parent::__construct($context);
        $felder = explode(',', 'id,anrede,titel,name,vorname,link,gname,gdatum,gort,str,ort,land_wohnort,land,land2,tel,email,
        homepage,bereich,pbereich,login1,login2' .
            ',uni_land,uni_ort,uni_name,uni_typ,uni_abschluss,uni_abschluss_name,uni_abschluss_datum' .
            ',prom_land,prom_ort,prom_name,prom_typ,prom_abschluss_name,prom_abschluss_datum' .
            ',aktiv,habilabsicht,newsletter,no_tg,no_tg_bemerkung,no_cg');
        $this->old['felder'] = array();
        $this->old['fnamen'] = array();
        for ($i = 0; $i < count($felder); $i++) {
            $this->old['felder'][$felder[$i]] = 'h.' . $felder[$i];
            $this->old['fnamen'][$felder[$i]] = ucfirst($felder[$i]);
        }
        $this->old['felder']['login1'] = 'b1.login';
        $this->old['felder']['login2'] = 'b2.login';

        $this->old['fnamen']['gname'] = 'Geburtsname';
        $this->old['fnamen']['gdatum'] = 'Geburtsdatum';
        $this->old['fnamen']['gort'] = 'Geburtsort';
        $this->old['fnamen']['str'] = 'Straße';
        $this->old['fnamen']['land_wohnort'] = 'Land Wohnort';
        $this->old['fnamen']['land'] = 'Nationalität';
        $this->old['fnamen']['land2'] = '2. Nationalität';
        $this->old['fnamen']['tel'] = 'Telefon';
        $this->old['felder']['link'] = "'<a href=\"../postdoc/index.php?id_obj='||h.id||'&tab=stamm\">Details</a>'";
        $this->old['fnamen']['link'] = 'Link zu Details';

        $this->old['fgroup']['uni_land'] = 'Uni Abschluss';
        $this->old['fnamen']['uni_land'] = 'Land des Abschlusses';
        $this->old['fnamen']['uni_ort'] = 'Stadt des Abschlusses';
        $this->old['fnamen']['uni_name'] = 'Name der Einrichtung';
        $this->old['fnamen']['uni_typ'] = 'Art der Einrichtung';
        $this->old['fnamen']['uni_abschluss'] = 'Art des Abschlusses';
        $this->old['fnamen']['uni_abschluss_name'] = 'Name des Abschlusses';
        $this->old['fnamen']['uni_abschluss_datum'] = 'Datum des Abschlusses';
        $this->old['felder']['bereich'] = 'non_empty(l.de,l.en)';
        $this->old['fnamen']['bereich'] = 'Einheit (Fachgruppe)';
        $this->old['felder']['pbereich'] = 'non_empty(pl.de,pl.en)';
        $this->old['fnamen']['pbereich'] = 'Obereinheit (Fakultät)';
        $this->old['fgroup']['prom_land'] = 'Promotion';
        $this->old['fnamen']['prom_land'] = 'Land der Promotion';
        $this->old['fnamen']['prom_ort'] = 'Stadt der Promotion';
        $this->old['fnamen']['prom_name'] = 'Name der Einrichtung';
        $this->old['fnamen']['prom_typ'] = 'Art der Einrichtung';
        $this->old['fnamen']['prom_abschluss_name'] = 'Name der Promotion';
        $this->old['fnamen']['prom_abschluss_datum'] = 'Datum der Promotion';
        $this->old['fnamen']['no_tg'] = 'Nicht Research Stay Grant antragsberechtigt';
        $this->old['fnamen']['no_tg_bemerkung'] = 'Nicht Research Stay Grant antragsberechtigt Bemerkung';
        $this->old['fnamen']['no_cg'] = 'Nicht CG antragsberechtigt';
        $this->old['fgroup']['aktiv'] = 'Status';

        $this->old['fgroup']['jp_beginn'] = 'Junior Professur';
        $this->old['felder']['jp_beginn'] = 'h.jp_beginn';
        $this->old['fnamen']['jp_beginn'] = 'Dienstbeginn';
        $this->old['felder']['jp_finanzierung'] = 'h.jp_finanzierung';
        $this->old['fnamen']['jp_finanzierung'] = 'Finanzierung';
        $this->old['felder']['jp_tenure'] = 'h.jp_tenure';
        $this->old['fnamen']['jp_tenure'] = 'Tenure Track';
        $this->old['felder']['jp_habil'] = 'h.jp_habil';
        $this->old['fnamen']['jp_habil'] = 'Gleichzeitige Habilitation an der Fakultät';
        $this->old['felder']['jp_ende1'] = 'h.jp_ende1';
        $this->old['fnamen']['jp_ende1'] = 'Ablauf der ersten Phase';
        $this->old['felder']['jp_ende2'] = 'h.jp_ende2';
        $this->old['fnamen']['jp_ende2'] = 'Ablauf der zweiten Phase';
        $this->old['felder']['jp_ende'] = 'h.jp_ende';
        $this->old['fnamen']['jp_ende'] = 'Enddatum der Juniorprofessur an der Universität Bayreuth';
        $this->old['felder']['jp_erlaut'] = 'h.jp_erlaut';
        $this->old['fnamen']['jp_erlaut'] = 'Erläuterungen';
        $this->old['felder']['jp_ze'] = 'h.jp_ze';
        $this->old['fnamen']['jp_ze'] = 'Datum Zwischenevaluation';
        $this->old['felder']['jp_ze_ok'] = 'h.jp_ze_ok';
        $this->old['fnamen']['jp_ze_ok'] = 'Ergebnis positiv';

        $this->old['fgroup']['hb_fach'] = 'Habilverfahren';
        $this->old['felder']['hb_fach'] = 'h.hb_fach';
        $this->old['fnamen']['hb_fach'] = 'Fach';
        $this->old['felder']['hb_titel'] = 'h.hb_titel';
        $this->old['fnamen']['hb_titel'] = 'Arbeitstitel der Habilitation';
        $this->old['felder']['hb_antrag'] = 'h.hb_antrag';
        $this->old['fnamen']['hb_antrag'] = 'Datum des Antrags';
        $this->old['felder']['hb_frist_vv'] = 'h.hb_frist_vv';
        $this->old['fnamen']['hb_frist_vv'] = 'Datum Frist zur Vervollständigung';
        $this->old['felder']['hb_zurueck_fa'] = 'h.hb_zurueck_fa';
        $this->old['fnamen']['hb_zurueck_fa'] = 'Datum Zurückweisung nach Fristablauf';
        $this->old['felder']['hb_frat'] = 'h.hb_frat';
        $this->old['fnamen']['hb_frat'] = 'Datum Fakultätsrat';
        $this->old['felder']['hb_annahme'] = 'h.hb_annahme';
        $this->old['fnamen']['hb_annahme'] = 'Datum der Annahme';
        $this->old['felder']['hb_ze_geplant'] = 'h.hb_ze_geplant';
        $this->old['fnamen']['hb_ze_geplant'] = 'Datum der Zwischenevaluierung (geplant)';
        $this->old['felder']['hb_ze'] = 'h.hb_ze';
        $this->old['fnamen']['hb_ze'] = 'Datum der Zwischenevaluierung';
        $this->old['felder']['hb_stl'] = 'h.hb_stl';
        $this->old['fnamen']['hb_stl'] = 'Übertragung der selbstständigen Wahrnehmung von Aufgaben in Forschung und Lehre';
        $this->old['felder']['hb_aussprache'] = 'h.hb_aussprache';
        $this->old['fnamen']['hb_aussprache'] = 'Datum der Aussprache mit Fachmentorat';
        $this->old['felder']['hb_vortag'] = 'h.hb_vortag';
        $this->old['fnamen']['hb_vortag'] = 'Datum des öffentlichen Vortrags';
        $this->old['felder']['hb_vortrag_titel'] = 'h.hb_vortrag_titel';
        $this->old['fnamen']['hb_vortrag_titel'] = 'Titel des öffentlichen Vortrags';
        $this->old['felder']['hb_nicht'] = 'h.hb_nicht';
        $this->old['fnamen']['hb_nicht'] = 'Datum Feststellung nicht-Erbringung der Leistungen durch Fachmentorat';
        $this->old['felder']['hb_aufhebung'] = 'h.hb_aufhebung';
        $this->old['fnamen']['hb_aufhebung'] = 'Datum Aufhebung Fachmentorat durch Fakultät';
        $this->old['felder']['hb_aufhebung_grund'] = 'h.hb_aufhebung_grund';
        $this->old['fnamen']['hb_aufhebung_grund'] = 'Grund der Aufhebung';
        $this->old['felder']['hb_bescheid'] = 'h.hb_bescheid';
        $this->old['fnamen']['hb_bescheid'] = 'Datum Bescheid Dekan an Habilitand';
        $this->old['felder']['hb_lehrbefugnis'] = 'h.hb_lehrbefugnis';
        $this->old['fnamen']['hb_lehrbefugnis'] = 'Erteilung der Lehrbefugnis';
        $this->old['felder']['hb_lehrbefugnis_datum'] = 'h.hb_lehrbefugnis_datum';
        $this->old['fnamen']['hb_lehrbefugnis_datum'] = 'Datum Lehrbefugnis';
        $this->old['felder']['hb_ende'] = 'h.hb_ende';
        $this->old['fnamen']['hb_ende'] = 'Endezeit Habilitationsstatus';
        $this->old['felder']['hb_verl'] = 'h.hb_verl';
        $this->old['fnamen']['hb_verl'] = 'Verlängerung durch Fachmentorat am';
        $this->old['felder']['hb_ende2'] = 'h.hb_ende2';
        $this->old['fnamen']['hb_ende2'] = 'Neue Endezeit';
        $this->old['felder']['hb_akt_erk'] = 'h.hb_akt_erk';
        $this->old['fnamen']['hb_akt_erk'] = 'Datum Abgabe aktualisierter Erklärungen und Angaben';
        $this->old['felder']['hb_schrift'] = 'h.hb_schrift';
        $this->old['fnamen']['hb_schrift'] = 'Datum Vorlage Habilitationsschrift';
        $this->old['felder']['hb_befuer'] = 'h.hb_befuer';
        $this->old['fnamen']['hb_befuer'] = 'Datum Befürwortung der Habilitation durch Fachmentorat';
        $this->old['felder']['hb_vortrag2'] = 'h.hb_vortrag2';
        $this->old['fnamen']['hb_vortrag2'] = 'Termin des öffentlichen Vortrags';
        $this->old['felder']['hb_ende3'] = 'h.hb_ende3';
        $this->old['fnamen']['hb_ende3'] = 'Abschlussdatum Habilitationsvorgang';
        $this->old['felder']['hb_lehrbefaehigung'] = 'h.hb_lehrbefaehigung';
        $this->old['fnamen']['hb_lehrbefaehigung'] = 'Lehrbefähigung';

        $this->old['fgroup']['pb_name'] = 'Betreuer';
        $this->old['felder']['pb_name'] = 'pb.nname';
        $this->old['fnamen']['pb_name'] = "Name Erstbetreuer";
        $this->old['felder']['pb_vname'] = 'pb.vname';
        $this->old['fnamen']['pb_vname'] = "Vorname Erstbetreuer";
        $this->old['felder']['pb_ls'] = 'pb.lehrstuhl';
        $this->old['fnamen']['pb_ls'] = "Lehrstuhl Erstbetreuer";
        $this->old['felder']['b_name'] = "b.was";
        $this->old['fnamen']['b_name'] = "Name";
        $this->old['felder']['b_datum'] = "b.datum";
        $this->old['fnamen']['b_datum'] = "Datum";
        $this->old['felder']['b_id'] = "b.id";
        $this->old['fnamen']['b_id'] = "ID";
        $this->old['felder']['b_kat'] = "case when b.kat=-1 then 'Gutschrift' when b.kat=0 then 'Festlegung' when b.kat=1 then 'Ausgabe' else 'unbekannt' end";
        $this->old['fnamen']['b_kat'] = "Kategorie";
        $this->old['felder']['b_betrag'] = "b.betrag";
        $this->old['fnamen']['b_betrag'] = "Betrag";
        $this->old['felder']['e_kat'] = "non_empty(" . $context->getLangLang2('gk.') . ")";
        $this->old['fnamen']['e_kat'] = "Geld-Kategorie";

        $doc_names = array(
            'cg_antrag' => 'Antrag Conference Grants',
            'cg_info' => 'Ergänzende Informationen zum Antrag',
            'cg_finanzen' => 'Detailinformation zur Finanzierung',
            'cg_sonstiges' => 'Sonstiges'
        );
        $docs = array_keys($doc_names);
        for ($i = 0; $i < count($docs); $i++) {
            if ($i == 0)
                $this->old['fgroup']["f_$docs[$i]_link"] = 'Conference Grant';
            $this->old['felder']["f_$docs[$i]_link"] = "'<a href=\"../../intern/baydoc/get_file.php?id='||file$i.id||'\">PDF</a>'";
            $this->old['fnamen']["f_$docs[$i]_link"] = $doc_names[$docs[$i]] . " (PDF-Link)";
            $this->old['felder']["f_$docs[$i]_time"] = "file$i.ts::date";
            $this->old['fnamen']["f_$docs[$i]_time"] = $doc_names[$docs[$i]] . " (Änderungsdatum)";
 
        }
        $this->old['fgroup']['tg_name']='Research Stay Grant Ausschreibung';
        $this->old['felder']['tg_name']="non_empty(tg.de,tg.en)";
        $this->old['fnamen']['tg_name']='Ausschreibung Name';
        $this->old['felder']['tg_bis']="tg.bis";
        $this->old['fnamen']['tg_bis']='Ausschreibung bis';
        $this->old['felder']['tg_von']="tg.von";
        $this->old['fnamen']['tg_von']='Ausschreibung von';
        $this->old['felder']['tg_max']="tg.max";
        $this->old['fnamen']['tg_max']='Ausschreibung max';
        
        
        
        $this->old['fgroup']['an_titel']='Research Stay Grant Antrag';
        $this->old['felder']['an_titel']="an.kurztitel";
        $this->old['fnamen']['an_titel']='Antrag Kurztitel';
        $this->old['felder']['an_ziel']="an.ziel";
        $this->old['fnamen']['an_ziel']='Reiseziel';
        $this->old['felder']['an_betrag']="an.betrag";
        $this->old['fnamen']['an_betrag']='Betrag';
        $this->old['felder']['an_von']="an.von";
        $this->old['fnamen']['an_von']='von';
        $this->old['felder']['an_bis']="an.bis";
        $this->old['fnamen']['an_bis']='bis';
        $this->old['felder']['an_geldgeber']="an.geldgeber";
        $this->old['fnamen']['an_geldgeber']='Geldgeber';
        $this->old['felder']['an_vorgesetzter']="an.abgesprochen_name";
        $this->old['fnamen']['an_vorgesetzter']='Vorgesetzter';
        $this->old['felder']['an_lehrstuhl']="an.abgesprochen_einheit";
        $this->old['fnamen']['an_lehrstuhl']='Einheit Vorgesetzter';
        $this->old['felder']['an_beschreibung']="an.beschreibung";
        $this->old['fnamen']['an_beschreibung']='Beschreibung';
        $this->old['felder']['an_qualziel']="an.qualiziel";
        $this->old['fnamen']['an_qualziel']='Qualifizierungsziel';
        $this->old['felder']['an_mot1']="an.motivation";
        $this->old['fnamen']['an_mot1']='Erwartungen hins. Vernetzung';
        $this->old['felder']['an_mot2']="an.annahmebestaetigung";
        $this->old['fnamen']['an_mot2']='Erwarteter Nutzen für eigene Forschung ';
        $this->old['felder']['an_status']="an.status";
        $this->old['fnamen']['an_status']='Status';
        $this->old['felder']['an_annahme']="an.annahme";
        $this->old['fnamen']['an_annahme']='Annahme';
    
        $this->old['fgroup']['eval_user']='Bewertungen';
		$this->old['felder']['eval_user']="eval_b.login";
		$this->old['fnamen']['eval_user']='Nutzer';
		$this->old['felder']['eval_punkte']="eval.punkte";
		$this->old['fnamen']['eval_punkte']='Punkte';
		$this->old['felder']['eval_bemerkung']="eval.bemerkung";
		$this->old['fnamen']['eval_bemerkung']='Bemerkung';



        $qb = new \BayDOC\QB\PostdocRSGEval($context);
        $sql_hash = [];
        $maps = [];
        foreach ($qb->getFields() as $f) {
            $sql_hash[$f->name] = $f->getSQL('t.','order');
        }
        $qb = new \BayDOC\QB\PostdocBuchung($context);
        foreach ($qb->getFields() as $f) {
            $sql_hash[$f->name] = $f->getSQL('t.','order');
        }
        $sql_hash_manual = [
            "non_empty(pl.de,pl.en)" => 'fak.de',
            "non_empty(l.de,l.en)" => 'prom_prog.de',
            'h.land' => 'nat1.name',
            'h.land2' => 'nat2.name'
        ];
        foreach ($this->old['felder'] as $key => $value) {
            if (isset($sql_hash_manual[$value])) {
                $value = $sql_hash_manual[$value];
            } else
                $value = $this->old2new($value);
            $keys = array_keys($sql_hash, $value);
            foreach ($keys as $name) {
                $this->field_map[$key] = $name;
                $maps[$name] = 1;
            }
        }

    }
}