<?php

namespace BayDOC\QB;

/**
 * QB:
 * Basetable: Buchungen (geld) joined with postdoc
 */
class PostdocBuchung extends Postdoc {
    public function __construct(\BayCMS\Base\BayCMSContext $context)
    {
        parent::__construct($context);

        $this->list_from.= ", baydoc_geld geld left outer join baydoc_gkat gk on geld.id_gkat=gk.id";
        $this->list_where.=" and geld.id_stud=t.id";
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'Buchungstext',
            div_id:'Buchung',
            sql: 'geld.was'
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'Buchungsdatum',
            div_id:'Buchung',
            sql: 'geld.datum'
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'Buchungs_ID',
            div_id:'Buchung',
            sql: 'geld.id'
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'Kategorie',
            div_id:'Buchung',
            sql: "case when geld.kat=-1 then 'Gutschrift' when geld.kat=0 then 'Festlegung' when geld.kat=1 then 'Ausgabe' else 'unbekannt' end"
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'Buchungsbetrag',
            div_id:'Buchung',
            sql: 'geld.betrag'
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'Geldkategorie',
            div_id:'Buchung',
            sql: 'non_empty(gk.de,gk.en)'
        ));
         
       


    }


    public function page(
        string $pre_content = '',
        string $post_content = ''
    ): void{
        if (isset($_GET['id'])) {
            $res = pg_query_params(
                $this->context->getDbConn(),
                'select id from postdoc where id=$1',
                [$_GET['id']]
            );
            if (pg_num_rows($res)) {
                header('Location: /'.$this->context->getOrgLinkLang().'/admin/postdoc/?tab=geld&id=' . $_GET['id']);
                exit();
            }
        }
        parent::page($pre_content, $post_content);

    }    
}