<?php

namespace BayDOC\Tabs;

class DocAdmin extends DocForm
{
    public function __construct(
        \BayCMS\Base\BayCMSContext $context,
        \BayDOC\Entry\Doc $doc
    ) {
        parent::__construct($context, $doc);
        $fields = \BayDOC\Util\AdminFields::getAdminFields($context->getOrgId());
        if ($fields === null)
            return;

        $res = pg_query($context->getDbConn(), "select * from baydoc limit 1");
        $field_hash = [];
        $field_class_hash=[
			'int8'=>'Number',
			'bool'=>'YesNo',
			'varchar'=>'TextInput',
			'bpchar'=>'TextInput',
			'date'=>'Date',
			'float8'=>'Number',
			'inet'=>'TextInput',
			'int4'=>'Number',
			'money'=>'Number',
			'numeric'=>'Number',
			'float4'=>'Number',
			'int2'=>'Number',
			'text'=>'Textarea',
			'time'=>'Time',
			'timetz'=>'Time',
			'timestamp'=>'Datetime',
			'timestamptz'=>'Datetime'];
        for ($i = 0; $i < pg_num_fields($res); $i++) {
            $field_hash[pg_field_name($res, $i)] = 1;
        }
        foreach($fields as $f){
            if($field_class_hash[$f[2]]){
                $name='f'.$context->getOrgId().'_'.$f[1];
                if(! isset($field_hash[$name])){
                    pg_query($context->getRwDbConn(),"alter table baydoc add $name $f[2]");
                }
                $class="\\BayCMS\\Field\\".$field_class_hash[$f[2]];
                $this->addField(new $class($context,$name,$f[0]));

            }
        }

    }

    public function getComment(): string
    {
        return "Diese Felder sind speziell für ihre Einheit und können auch nur von Ihrer Einheit editiert und eingesehen werden";
    }

    public function editAllowed(): bool
    {
        return $this->doc->getRole()=='admin';
    }

}