<?php

namespace BayDOC\Tabs;

abstract class DocAdministration extends DocForm
{
    protected array $admin_actions;
    public function save()
    {
        $id = parent::save();
        if ($id) {
            pg_query_params(
                $this->context->getRwDbConn(),
                'insert into '.$this->doc->getVTable().'(id_stud,id_benutzer,bemerkung)
                values ($1,$2,$3);',
                [$id, $this->context->getUserId(), $_POST['action'] . ($_POST['action_comment'] ? ": $_POST[action_comment]" : '')]
            );

        }
        return $id;

    }

    protected function addAdminFields(){
        $this->addField(new \BayCMS\Field\Select(
            $this->context,
            'action',
            'Bearbeiter-Aktion',
            values: $this->admin_actions,
            null: true,
            non_empty: true,
            no_add_to_query: true,
            not_in_table: true
        ));
        $this->addField(new \BayCMS\Field\Textarea(
            $this->context,
            'action_comment',
            'Bearbeiter Kommenentar',
            no_add_to_query: true,
            not_in_table: true
        ));

    }

    public function getAdminHistory(): string
    {
        $out = '
<h3>Bearbeitungshistorie</h3>
<table border>
<tr><th>Datum</th><th>Bearbeiter</th><th>Aktion</th></tr>';

        $or=[];
        foreach($this->admin_actions as $action){
            $or[]="v.bemerkung like '".addslashes($action)."%'"; 
        }
        $res = pg_query_params(
            $this->context->getDbConn(),
            'select b.*, to_char(v.wann,\'DD.MM.YYYY HH24:MI\'), v.bemerkung
	from benutzer b,'.$this->doc->getVTable().' v where v.id_stud=$1 
    and v.id_benutzer=b.id and ('.implode(' or ',$or).') order by v.wann desc',
            [$this->doc->getId()]
        );
        for ($i = 0; $i < pg_num_rows($res); $i++) {
            $r = pg_fetch_array($res, $i);
            $out .= "<tr><td>$r[to_char]</td><td>$r[kommentar] ($r[login])</td><td>$r[bemerkung]</td></tr>\n";

        }
        $out .= "</table>";
        return $out;
    }

    public function editAllowed(): bool
    {
        return $this->doc->getRole() == 'admin' && !$this->doc->locked();
    }

    public function print()
    {
        parent::print();
        if (!isset($_GET['aktion'])) {
            if ($this->doc->getRole() == 'admin')
                echo $this->getAdminHistory();
        }

    }


}