<?php

namespace BayDOC\Tabs;

abstract class DocForm extends \BayCMS\Fieldset\Form
{

    protected \BayDOC\Entry\Doc $doc;
    protected bool $skip_empty = false;

    public function __construct(
        \BayCMS\Base\BayCMSContext $context,
        \BayDOC\Entry\Doc $doc
    ) {
        $this->doc = $doc;
        $tab = $_GET['tab'] ?? 'stamm';
        $de = ($_POST['vorname'] ?? false) ? $_POST['vorname'] . ' ' . $_POST['name'] : null;
        parent::__construct(
            $context,
            table: $doc->getTable(),
            uname: $doc->getTable(),
            qs: "tab=" . $tab,
            id_name: 'id',
            delete_button: false,
            cancel_button: false,
            object_button: false,
            de: $de,
            en: $de
        );
    }
    public function editAllowed(): bool
    {
        return true;
    }

    public function getJSRedirect($url)
    {
        return '<script type="text/javascript">
					<!--
					window.location = "' . $url . '";
					//-->
					</script>';
    }

    public function getComment(): string
    {
        return '';
    }

    protected function getNextTab(): string {
        $t=$_GET['tab']??'';
        if($this->doc->getTable()=='postdoc'){
            if($t=='stamm') return 'betr';
            if($t=='betr') return 'register';
            return '';
        }
        if($t=='stamm') return 'uni';
        if($t=='uni') return 'betr';
        if($t=='betr') return 'prom';
        if($t=='prom') return 'register';
        return '';
    }

    public function print()
    {
        $this->load($this->doc->getId());
        if (($_GET['aktion'] ?? false) && !$this->editAllowed())
            unset($_GET['aktion']);
        if ($_GET['aktion'] ?? '') {
            if ($_GET['aktion'] == 'save') {
                $error = $this->setValues($_POST);
                if ($error)
                    $_GET['aktion'] = "edit";
            }

            if ($_GET['aktion'] == 'save') {
                $this->save();
                $GLOBALS['TE']->printMessage($this->t('Saved entry', "Eintrag gespeichert"));
                unset($_GET['aktion']);
                if ($this->doc->getAntrag() && ($tab=$this->getNextTab()))
                    echo $this->getJSRedirect("?tab=$tab&id=" . $this->doc->getId() . "&aktion=edit");
            } else {
                echo $this->getForm($this->t('Edit Entry', 'Eintrag bearbeiten'));
            }
        }
        if (!isset($_GET['aktion'])) {
            $comment = $this->getComment();
            if ($comment)
                $GLOBALS['TE']->printMessage($comment);
            echo $this->getTable(delete_link: false, edit_link: $this->editAllowed(), object_link: false, pos: 'top', skip_empty: $this->skip_empty);

        }

    }


}