<?php

namespace BayDOC\Tabs;

use BayCMS\Field\Checkbox;
use \BayCMS\Field\Select;
use \BayCMS\Field\Textarea;

class DocLock extends DocAdministration
{
    public function __construct(
        \BayCMS\Base\BayCMSContext $context,
        \BayDOC\Entry\Doc $doc
    ) {
        parent::__construct($context, $doc); 
        $this->admin_actions=['Sperrung'];       
        
        $this->addField(new Checkbox(
            $context,
            'locked',
            'Bearbeitung durch Admin/Doktorand sperren'
        ));
        $this->addField(new Select(
            $context,
            'action',
            'Bearbeiter-Aktion',
            values: $this->admin_actions,
            null: true,
            non_empty: true,
            no_add_to_query: true,
            not_in_table: true
        ));
        $this->addField(new Textarea(
            $context,
            'action_comment',
            'Bearbeiter Kommenentar',
            no_add_to_query: true,
            not_in_table: true
        ));
    }
    public function editAllowed(): bool
    {
        return $this->doc->getRole() == 'admin';
    }

    
}