<?php

namespace BayDOC\Tabs;

class DocPdf extends Doc
{
    public function getComment(): string
    {
        if ($this->doc->getRole() == 'admin')
            return "Die Abrufbarkeit der PDF/DOCX-Dokumente hängt davon ab, ob der Doktorand auch in der zugrundeliegenden Abfrage
	aufgeführt wird.";
        return $this->t(
            'Please note that it depends on your admission status wheather you are allowed to download all files',
            'Bitte beachten Sie, dass Sie je nach Zulassungsstatus manche Dateien nicht herunterladen dürfen'
        );
    }

    public function print()
    {
        $GLOBALS['TE']->printMessage($this->getComment());

        $list = new \BayCMS\Fieldset\BayCMSList(
            $this->context,
            "(select c.name, '<a href=\"../../intern/baydoc/pdf.php?id=" . $this->doc->getId() . "&id_obj='||c.id||'\" target=\"_blank\">" . $this->t("show", 'anzeigen') . "</a>' as link
        from qb_contact c,objekt_verwaltung" . $this->context->getOrgId() . " o, qb_querys q, qb_tables t
        where o.id=c.id and c.id_query=q.id and q.id_table=t.id and t.name ilike 'BayDOC Doktoranden%' and
			c.pdf_anz>0" . ($this->context->kategorie == 'intern' ? ' and c.power<=100' : '') . " 
    union
        select c.name, '<a href=\"../../intern/baydoc/p.php?id=" . $this->doc->getId() . "&id_obj='||c.id||'\" target=\"_blank\">" . $this->t("show", 'anzeigen') . "</a>'
        from qb2_document c,objekt_verwaltung" . $this->context->getOrgId() . " o, qb2 q
        where o.id=c.id and c.id_query=q.id and q.class ilike 'BayDOC\\\\QB\\\\Doc' " . ($this->context->kategorie == 'intern' ? ' and c.min_power<=100' : '') . "
        ) t",
            'true',
            qs: "tab=pdf&id=" . $this->doc->getId()
        );

        $list->addField(new \BayCMS\Field\TextInput($this->context, 'name', 'PDF-Formular'));
        $list->addField(new \BayCMS\Field\TextInput($this->context, 'link', 'Download Link'));
        echo $list->getTable();

    }
}