<?php

namespace BayDOC\Tabs;

class PostdocAnstellung extends Tab
{
    private \BayCMS\Fieldset\Domain $domain;
    private array $org_ids;
    public function __construct(
        \BayCMS\Base\BayCMSContext $context,
        \BayDOC\Entry\Doc $doc
    ) {
        parent::__construct($context, $doc);
        $this->domain = new \BayCMS\Fieldset\Domain(
            $context,
            'postdoc_anstellung',
            'Anstellungen',
            qs: 'tab=anstellung&id=' . $doc->getId(),
            id_name: 'id_an',
            from: 'postdoc_anstellung t join postdoc_anstellungsstatus s on s.id=t.id_status',
            where: 't.id_postdoc='.$doc->getId()
        );
        $this->domain->addField(new \BayCMS\Field\Date(
            $context,
            'Von',
            non_empty:1
        ),list_field:1);
        $this->domain->addField(new \BayCMS\Field\Date(
            $context,
            'Bis'
        ),list_field:1);
        $this->domain->addField(new \BayCMS\Field\SelectJS(
            $context,
            'id_status',
            '../../admin/postdoc/status.php',
            'Status',
            db_query:'select id,name as description from postdoc_anstellungsstatus',
            sql:'s.name',
            non_empty:1
        ),list_field:1);
        $this->domain->addField(new \BayCMS\Field\Hidden(
            $context,
            'id_postdoc',
            default_value: $doc->getId(),
            type: 'integer'
        ));
        $this->domain->setListProperties(export_buttons: false);
    }

    public function print(){
        $this->domain->pagePostHeader();
    }
}