<?php

namespace BayDOC\Tabs;

class PostdocHabil extends DocAdministration {
    public function __construct(
        \BayCMS\Base\BayCMSContext $context,
        \BayDOC\Entry\Doc $doc
    ) {
        parent::__construct($context, $doc);
        $this->skip_empty = true;
        $this->admin_actions = ['Habilverfahren'];
        $this->addAdminFields();

        $this->addField(new \BayDOC\Field\FachSelectJS(
            $context,
            'hb_fach',
            'Fach',
            div_id: 'Daten'
        ));
        $this->addField(new \BayCMS\Field\Textarea(
            $context,
            'hb_titel',
            'Arbeitstitel der Habilitation'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'hb_annahme',
            'Datum der Annahme'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'hb_ze_geplant',
            'Datum der Zwischenevaluierung (geplant)',
            input_options: ' disabled readonly'
        ));
        $this->addField(new \BayCMS\Field\Comment(
            $context,
            'eval',
            '<h3>Zwischenevaluierung</h3>',
            div_id: 'Zwischenevaluierung'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'hb_ze',
            'Datum der Zwischenevaluation'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'hb_stl',
            'Übertragung der selbstständigen Wahrnehmung von Aufgaben in Forschung und Lehre'
        ));
        $this->addField(new \BayCMS\Field\Comment(
            $context,
            'auf',
            '<h3>Aufhebung</h3>',
            div_id: 'Aufhebung'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'hb_aufhebung',
            'Datum Aufhebung Fachmentorat durch Fakultät'
        ));
        $this->addField(new \BayCMS\Field\Textarea(
            $context,
            'hb_aufhebung_grund',
            'Grund der Aufhebung'
        ));
        $this->addField(new \BayCMS\Field\Comment(
            $context,
            'ab',
            '<h3>Abschluss</h3>',
            div_id: 'Abschluss'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'hb_ende',
            'Endezeit Habilitationsstatus',
            input_options: ' readonly disabled'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'hb_verl',
            'Verlängerung durch Fachmentorat am'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'hb_ende2',
            'Neue Endezeit'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'hb_ende3',
            'Abschlussdatum Habilitationsvorgang'
        ));
        $this->addField(new \BayCMS\Field\YesNo(
            $context,
            'hb_lehrbefugnis',
            'Erteilung der Lehrbefugnis'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'hb_lehrbefugnis_datum',
            'Datum Lehrbefugnis'
        ));
    }
}