<?php

namespace BayDOC\Tabs;

class PostdocJp extends DocAdministration
{
    public function __construct(
        \BayCMS\Base\BayCMSContext $context,
        \BayDOC\Entry\Doc $doc
    ) {
        parent::__construct($context, $doc);
        $this->skip_empty = true;
        $this->admin_actions = ['Junior Professur'];
        $this->addAdminFields();

        $this->addField(new \BayCMS\Field\Date(
            $context,
            'jp_beginn',
            'Dienstbeginn',
            div_id: 'Daten'
        ));
        $this->addField(new \BayCMS\Field\Textarea(
            $context,
            'jp_finanzierung',
            'Finanzierung'
        ));
        $this->addField(new \BayCMS\Field\YesNo(
            $context,
            'jp_tenure',
            'Tenure Track'
        ));
        $this->addField(new \BayCMS\Field\YesNo(
            $context,
            'jp_habil',
            'Gleichzeitige Habilitation an der Fakultät'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'jp_ende1',
            'Ablauf der ersten Phase'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'jp_ende2',
            'Ablauf der zweiten Phase'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'jp_ende',
            'Enddatum der Juniorprofessur an der Universität Bayreuth'
        ));
        $this->addField(new \BayCMS\Field\Textarea(
            $context,
            'jp_erlaut',
            'Erläuterung'
        ));
        $this->addField(new \BayCMS\Field\Comment(
            $context,
            'eval',
            '<h3>Zwischenevaluierung</h3>',
            div_id: 'Zwischenevaluierung'
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'jp_ze',
            'Datum der Zwischenevaluation'
        ));
        $this->addField(new \BayCMS\Field\YesNo(
            $context,
            'jp_ze_ok',
            'Ergebnis positiv'
        ));
        $this->addField(new \BayCMS\Field\Comment(
            $context,
            'zp',
            '<h4>Zeitplan für Zwischenevaluation (laut Leitfaden):</h4>
<p>Verfahrenseröffnung durch den Fachbereichsrat (2 Jahre 6 Monate nach Dienstbeginn)<br/>
Selbstbericht des Juniorprofessors (2 Jahre, 7 Monate nach Dienstbeginn)<br/>
Benennung der Evaluationskommission durch den Fachbereichsrat (2 Jahre, 7 Monate nach Dienstbeginn)<br/>
Bestimmung der Gutachter durch die Evaluationskommission (2 Jahre, 7 Monate nach Dienstbeginn)<br/>
Bericht der Gutachter(2 Jahre, 9 Monate nach Dienstbeginn)<br/>
Bericht der Evaluationskommission (2 Jahre, 10 Monate nach Dienstbeginn)<br/>
Stellungnahme des Juniorprofessors (2 Jahre, 10 Monate nach Dienstbeginn)<br/>
Beschluss des Fachbereichsrats (2 Jahre, 11 Monate nach Dienstbeginn)<br/>
Bearbeitung durch die Personalabteilung (2 Jahre, 11 Monate nach Dienstbeginn)</p>'
        ));



    }


}