<?php

namespace BayDOC\Tabs;

class PostdocRegister extends DocForm
{
    public function __construct(
        \BayCMS\Base\BayCMSContext $context,
        \BayDOC\Entry\Doc $doc
    ) {
        parent::__construct($context, $doc);
        $this->addField(new \BayCMS\Field\Checkbox(
            $context,
            'hinweise_gelesen',
            $this->t(
                'I agree that the University of Bayreuth may use this information for internal purposes',
                'Ich stimme zu, dass die Universität Bayreuth diese Angaben für interne verwendet'
            ),
            no_add_to_query: 1,
            non_empty: 1
        ));

    }

    private function finish(){
        ignore_user_abort(true);
        $id = $this->doc->getId();
        $r = $this->doc->getRow();
        $r['b_token'] = md5(random_bytes(20));
        $r['m1_token'] = md5(random_bytes(20));
        $r['m2_token'] = md5(random_bytes(20));
        $r['m3_token'] = md5(random_bytes(20));
        pg_query_params(
            $this->context->getRwDbConn(),
            'update postdoc set
		b_token=$2,
		m1_token=$3,
		m2_token=$4,
		m3_token=$5,antrag=false where id=$1',
            [$id, $r['b_token'], $r['m1_token'], $r['m2_token'], $r['m3_token']]
        );
        $translations = [];
        $translations['en']['Herr'] = 'Mr';
        $translations['en']['Frau'] = 'Ms';        
        $ls_link=$this->context->org_folder;
        $r['student_anrede_de']=$r['anrede']?'Liebe'.($r['anrede']=='Herr'?'r':'').' '.$r['anrede']:'Guten Tag';
        $r['student_anrede_en']=$r['anrede']?'Dear '.$translations['en'][$r['anrede']]:'Hello';
        $r['herr_frau_de']=$r['anrede'];
        $r['herr_frau_en']=$translations['en'][$r['anrede']];
        $r['admin_link'] = "https://$_SERVER[HTTP_HOST]/$ls_link/de/admin/postdoc/?id_obj=$id";
        $r['intern_link'] = "https://$_SERVER[HTTP_HOST]/$ls_link/de/intern/postdoc/?id_obj=$id";
        $mail = new \BayDOC\Util\Mail($this->context);
        $mail->sendMail(
            $r['email'],
            $mail->getMailText('student_neuer_antrag_betreff',modul:'postdoc'),
            $mail->getMailText('student_neuer_antrag',modul:'postdoc'),
            $r,
            ids: [$id]
        );
        $mail->sendMail(
            $mail->getAdmins(),
            "Neuer Antrag von $r[name], $r[vorname]",
            $mail->getMailText('admin_neuer_antrag',modul:'postdoc'),
            $r
        );
        echo $this->getJSRedirect("?tab=stamm");

    }


    public function print()
    {
        if (!$this->doc->getAntrag()) {
            $GLOBALS['TE']->printMessage($this->t(
                'Registration Process is finished',
                'Registrierung ist bereits abgeschlossen'
            ), 'danger');
            return;
        }
        if (($_GET['aktion'] ?? false) && !$this->editAllowed())
        unset($_GET['aktion']);
    if ($_GET['aktion'] ?? '') {
        if ($_GET['aktion'] == 'save') {
            $error = $this->setValues($_POST);
            if ($error)
                $_GET['aktion'] = "edit";
        }
        if ($_GET['aktion'] == 'save') {
            //Registration Staff!
            $this->finish();

            return;
        }
    }

    $GLOBALS['TE']->printMessage($this->getComment());
    echo $this->getForm($this->t('Finish Registration', 'Registrierung abzuschließen'));


    }


}
