<?php

namespace BayDOC\Tabs;

class ProfGutachten extends \BayCMS\Base\BayCMSBase
{
    protected \BayDOC\Entry\Prof $prof;

    public function __construct(
        \BayCMS\Base\BayCMSContext $context,
        \BayDOC\Entry\Prof $prof,
    ) {
        $this->prof = $prof;
        $this->context = $context;
    }

    public function print()
    {
        $id = $this->prof->getId();
        $where="(s.prue_gut1_id=$id or s.prue_gut2_id=$id or s.prue_gutw_id=$id)";
        $list = new \BayCMS\Fieldset\BayCMSList(
            $this->context,
            "baydoc s,lehrstuhl l, objekt o left outer join objekt_ls ol on ol.id_obj=o.id and ol.id_lehr=" . $this->context->getOrgId(),
            's.id_lehr=l.id and s.id=o.id and o.geloescht is null and not s.antrag and ' . $where,
            step: -1
        );
        $list->addField(new \BayCMS\Field\TextInput(
            $this->context,
            'Name',
            sql: "case when ol.id_lehr is null then s.name||', '||s.vorname 
      else '<a href=\"index.php?tab=stamm&id_obj='||s.id||'\">'||s.name||', '||s.vorname||'</a>' end"
        ));
        $list->addField(new \BayCMS\Field\TextInput(
            $this->context,
            'Bereich',
            sql:"non_empty(".$this->context->getLangLang2('l.').")"
        ));
        echo $list->getTable();

    }

}