<?php

namespace BayDOC\Tabs;

class ProfStamm extends \BayCMS\Fieldset\Form
{
    protected \BayDOC\Entry\Prof $prof;
    public function __construct(
        \BayCMS\Base\BayCMSContext $context,
        \BayDOC\Entry\Prof $prof
    ) {
        $this->prof = $prof;
        $this->id = $prof->getId();
        parent::__construct($context, table: 'bayprof', uname: 'bayprof');
        $this->addField(new \BayDOC\Field\Anrede(
            $context,
            'anrede',
            $this->t('Salutation', 'Anrede'),
            not_in_table: 1
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'titel',
            $this->t('Title', 'Titel'),
            non_empty: 1,
            not_in_table: 1
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'vname',
            $this->t('Firstname', 'Vorname'),
            non_empty: 1,
            not_in_table: 1
        ))->set(['list_field' => 1]);
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'nname',
            $this->t('Surname', 'Nachname'),
            non_empty: 1,
            not_in_table: 1
        ))->set(['list_field' => 1]);
        $this->addField(new \BayCMS\Field\Email(
            $context,
            'email',
            $this->t('E-Mail Address', 'E-Mail Adresse'),
            non_empty: 1
        ));
        $this->addField(new \BayCMS\Field\URL(
            $context,
            'url',
            $this->t('Homepage (incl. https://)', 'Homepage (mit https://)'),
            non_empty: 0
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'lehrstuhl',
            $this->t('Department', 'Lehrstuhl'),
            non_empty: 0
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'lehrstuhl_en',
            $this->t('Department (en)', 'Lehrstuhl (en)'),
            non_empty: 0
        ));
        $this->addField(new \BayCMS\Field\Checkbox(
            $context,
            'admin_ok',
            $this->t('Checked by admin', 'Admin geprüft')
        ));

        $this->addField(new \BayCMS\Field\Select(
            $context,
            'gruppe',
            $this->t('Group', 'Gruppe'),
            null: 1,
            non_empty: 1,
            values: ['Universitätsprofessoren', 'Professoren', 'Juniorprofessoren', 'apl. Professoren', 'Privatdozenten', 'Habilitanden', 'Sonstige']
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'von',
            $this->t('From', 'Seit')
        ));
        $this->addField(new \BayCMS\Field\Date(
            $context,
            'bis',
            $this->t('Until', 'Bis')
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'neue_stelle',
            'Neue Universität/Pensionierung'
        ));
        $this->addField(new \BayCMS\Field\Select(
            $context,
            'fakultaet',
            $this->t('Faculty', 'Fakultät/Fachgruppe'),
            null: 1,
            non_empty: 1,
            values: [
                'I',
                'I/Mathematik',
                'I/Physik',
                'I/Informatik',
                'II',
                'II/Biologie',
                'II/Chemie',
                'II/Geowissenschaften',
                'III',
                'III/Rechtswissenschaften',
                'III/Wirtschaftswissenschaften',
                'IV',
                'IV/Afrikanistik',
                'IV/Anglistik',
                'IV/Arabistik',
                'IV/Germanistik',
                'IV/Islamwissenschaft',
                'IV/Medienwissenschaft',
                'IV/MusikTheater',
                'IV/Romanistik',
                'V',
                'V/Erziehungswissenschaften',
                'V/Ethnologie',
                'V/Geschichte',
                'V/Philosophie',
                'V/Religionswissenschaft',
                'V/Soziologie',
                'V/Sportwissenschaft',
                'VI',
                'VI/Ingenieurwissenschaften',
                'VII',
                'VII/Ernährung',
                'VII/Gesundheit',
                'VII/Lebensmittel',
                'Sonstige UBT',
                'Nicht UBT',
                'Ehemals UBT',
                'Unbekannt'
            ]
        ));
        $this->addField(new \BayCMS\Field\SelectJS(
            $context,
            'hstatg_hs',
            'stat_hs.php',
            'Universität (nach Bundesschlüssel)',
            db_query: 'select id,name as description from stat_hs where id=$1'
        ));
        $this->addField(new \BayCMS\Field\TextInput(
            $context,
            'faecher_ids',
            'IDs der erlaubten Promotionsfächer'
        ));
        $this->addField(new \BayCMS\Field\Textarea(
            $context,
            'Bemerkung'
        ));
        $this->addField(new \BayCMS\Field\Checkbox(
            $context,
            'aktiv',
            'Aktiv (u.a. notwendig für Bestätigungsmails)'
        ));
        $this->addField(new \BayCMS\Field\UploadImage(
            $context,
            'bild',
            $this->t('Image', 'Bild'),
            height: 180,
            not_in_table: 1
        ));
        $this->addField(new \BayCMS\Field\SelectJS(
            $context,
            'id_benutzer',
            description: $this->t('User account', 'Zugeordnete Nutzerkennung'),
            target: '../../intern/gru/user_select.php',
            db_query: "select id,login||' ('||kommentar||')' as description from benutzer where id=\$1"
        ))->set(['left_join' => 'user', 'left_join_name' => 'user1']);
        $this->addField(new \BayCMS\Field\SelectJS(
            $context,
            'id_benutzer2',
            description: $this->t('2nd user account', 'alternative Nutzerkennung (z.B. s-Kennung)'),
            target: '../../intern/gru/user_select.php',
            db_query: "select id,login||' ('||kommentar||')' as description from benutzer where id=\$1"
        ))->set(['left_join' => 'user', 'left_join_name' => 'user2']);

        $this->addField(new \BayCMS\Field\Checkbox(
            $context,
            'set_zugriff',
            'Rechte setzen auf Doktoranden+Mentorate+Habilitanden',
            no_add_to_query: 1,
            not_in_table: 1
        ));


    }

    public function del()
    {
        if (($_GET['aktion'] ?? false) != 'del')
            return;
        if (!$this->editAllowed()) {
            unset($_GET['aktion']);
            $GLOBALS['TE']->printMessage('Missing rights', 'danger');
            return;
        }
        $res = pg_query_params(
            $this->context->getDbConn(),
            'select d.id from baydoc d, objekt o where d.id=o.id and (d.b_id=$1 or d.m1_id=$1 or d.m2_id=$1 or d.m3_id=$1)
            union
            select d.id from postdoc d, objekt o where d.id=o.id and (d.b_id=$1 or d.m1_id=$1 or d.m2_id=$1 or d.m3_id=$1)',
            [$_GET['id']]
        );
        if (pg_num_rows($res)) {
            unset($_GET['aktion']);
            $GLOBALS['TE']->printMessage('Es gibt noch Doktorande/Postdocs, die auf diesen Eintrag verweisen.', 'danger');
            return;
        }
        $obj = new \BayCMS\Base\BayCMSObject($this->context);
        $obj->load($_GET['id']);
        pg_query($this->context->getRwDbConn(), "begin");

        try {
            $obj->erase(true);
            pg_query($this->context->getRwDbConn(), "commit");
            $GLOBALS['TE']->printMessage("Eintrag gelöscht!");
            echo $GLOBALS['TE']->getActionLink('./bayprof.php', 'zurück zur Übersicht', '', 'arrow-left');
            $this->context->printFooter();
        } catch (Exception $e) {
            $GLOBALS['TE']->printMessage("Konnte Objekt nicht löschen: " . $e->getMessage(), 'danger');
        }
        unset($_GET['aktion']);

    }

    public function editAllowed(): bool
    {
        if (!$this->prof->getId())
            return true;
        if ($this->prof->getRow()['check_objekt'] == 't')
            return true;
        return false;
    }
    public function print()
    {
        $this->load($this->prof->getId());
        if (($_GET['aktion'] ?? false) && !$this->editAllowed())
            unset($_GET['aktion']);

        $this->del();
        if ($_GET['aktion'] ?? '') {
            if ($_GET['aktion'] == 'save') {
                $error = $this->setValues($_POST);
                if ($error)
                    $_GET['aktion'] = "edit";
            }

            if ($_GET['aktion'] == 'save') {
                $id = $this->save();
                if ($_POST['set_zugriff'] ?? false) {
                    pg_prepare(
                        $this->context->getRwDbConn(),
                        'set_zugriff',
                        'insert into zugriff(id_benutzer,id_obj)
                            select $1,$2 except select id_benutzer,id_obj from zugriff where id_benutzer=$1 and id_obj=$2'
                    );
                    $res = pg_query_params(
                        $this->context->getDbConn(),
                        'select d.id from baydoc d, objekt o where d.id=o.id and not d.antrag and o.geloescht is null and (d.b_id=$1 or d.m1_id=$1 or d.m2_id=$1 or d.m3_id=$1)
                        union 
                        select d.id from postdoc d, objekt o where d.id=o.id and not d.antrag and o.geloescht is null and (d.b_id=$1 or d.m1_id=$1 or d.m2_id=$1 or d.m3_id=$1)',
                        [$this->prof->getId()]
                    );
                    pg_query($this->context->getRwDbConn(), 'begin');
                    for ($i = 0; $i < pg_num_rows($res); $i++) {
                        [$id] = pg_fetch_row($res, $i);
                        if (is_numeric($_POST['id_benutzer']))
                            pg_execute(
                                $this->context->getRwDbConn(),
                                'set_zugriff',
                                [$_POST['id_benutzer'], $id]
                            );
                        if (is_numeric($_POST['id_benutzer2']))
                            pg_execute(
                                $this->context->getRwDbConn(),
                                'set_zugriff',
                                [$_POST['id_benutzer2'], $id]
                            );
                    }
                    pg_query($this->context->getRwDbConn(), 'commit');

                }

                $GLOBALS['TE']->printMessage($this->t('Saved entry', "Eintrag gespeichert"));
                unset($_GET['aktion']);
            } else {
                echo $this->getForm($this->t('Edit Entry', 'Eintrag bearbeiten'));
            }
        }
        if (!isset($_GET['aktion'])) {
            echo '<p style="float:right;">' . $this->getField('bild')->getHTML() . '</p>';
            $r = $this->getValues();
            echo '<p>' . $r['anrede'] . '</p><h4>' . $r['titel'] . ' ' . $r['vname'] . ' ' . $r['nname'] . '</h4>';
            echo $this->getTable(
                delete_link: $this->editAllowed(),
                edit_link: $this->editAllowed(),
                object_link: true
            );

        }

    }
}