<?php

namespace BayDOC\Util;

class Filter
{
    public static string $sql_ef13_date = "case when t.pstart2 is not null then t.pstart2
    when t.zulassung_zulassung is not null then t.zulassung_zulassung
    else t.zulassung end";
    public static string $sql_ef14_date = "greatest(t.prue_urkunde,case when t.prue_nichtbestanden is not null then t.prue_nichtbestanden 
when t.abbruch_best is not null then t.abbruch_best else t.abbruch end)";

    public static int $hstatg_year = 2025;

    public static function getPostfilterHStatG()
    {
        $filter = [];
        $year = 2017;
        while ($year < self::$hstatg_year) {
            $filter['hstatg' . $year] = ['HStatG ' . $year . ' - abgeschlossen', "t.hstatg" . $year . ">''"];
            $year++;
        }
        $hstatg_start = (self::$hstatg_year - 1) . '-12-02';
        $hstatg_end = self::$hstatg_year . '-12-01';

        $filter['hstatg' . self::$hstatg_year] =
            [
                'HStatG 2025',
                "not t.no_hstatg
        and (greatest(t.prue_urkunde,t.abbruch_best,t.abbruch) is null or
        greatest(t.prue_urkunde,t.abbruch_best,t.abbruch)>='" . $hstatg_start . "')
        and s.id_status>0
        and (t.hstatg_ef14 is null or t.hstatg_ef14='')
        and " . self::$sql_ef13_date . "<='" . $hstatg_end . "'"
            ];
        return $filter;

    }

    public static function getPostfilterStatus(\BayCMS\Base\BayCMSContext $context,$use_ubt_status=false)
    {
        $filter = [];
        $res = pg_query(
            $context->getDbConn(),
            "select id,non_empty(de,en) from baydoc_zulassungskat order by 2"
        );
        for ($i = 0; $i < pg_num_rows($res); $i++) {
            $r = pg_fetch_array($res, $i);
            $filter['status_eq_' . $r['id']] = ["Status $r[non_empty]", (! $use_ubt_status ? " s.id_status=$r[id]" : "t.ubt_status=$r[id]")];
        }
        $res = pg_query(
            $context->getDbConn(),
            "select id,non_empty(de,en) from baydoc_zulassungskat order by 1"
        );
        for ($i = 0; $i < pg_num_rows($res); $i++) {
            $r = pg_fetch_array($res, $i);
            $filter['status_lt_' . $r['id']] = ["Status &le; $r[non_empty]", (! $use_ubt_status ? "s.id_status<=$r[id]" : "t.ubt_status<=$r[id]")];
        }
        return $filter;
    }


}